/**
* @file MIDdialog2.cpp
* @brief p[^ݒpWindows_CAÕnh[iMIDIҏWj
* @author T.Modegi
* @date  2019.1.22
*/
#include "stdafx.h"
#include <stdio.h>
#include <commdlg.h>
#include "resource.h"
#include "common.h"
#include "commdata.h"
#include "commparam.h"
#include "INITfile.h"
#include "MIDout.h"
#include "MIDdialog2.h"
#include "MIDfile.h"
#include "MIDedit.h"

extern HWND hWnd_main;
int record_status=0;

/**
* @fn Setup_MIDIfilter
* @brief MIDIf[^tB^E_CAO{bNXpbZ[W nh
* @param (hDlg) Windows Dialog̃nh
* @param (message,wParam,lParam) WindowsCxgbZ[Wуp[^
* @return Ȃ
* @sa
* @detail IDD_MIDI_FILTER
*/
LRESULT CALLBACK Setup_MIDIfilter(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	BOOL stat;
	switch(uMsg)
	{
	case WM_INITDIALOG:
		SetDlgItemInt(hDlg,IDC_EDIT1,flt_key_min,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT2,flt_key_max,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT3,flt_level_min,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT4,flt_length_min,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT5,flt_diff_level,TRUE);
		SetDlgItemInt(hDlg,IDC_EDIT6,flt_interval_max,FALSE);
		if (flt_connect) CheckDlgButton(hDlg,IDC_CHECK1,1);
		else  CheckDlgButton(hDlg,IDC_CHECK1,0);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDCANCEL:
			EndDialog(hDlg,IDCANCEL);
			break;
		case IDC_CHECK1:
			flt_connect= !flt_connect;
			if (flt_connect) {
				CheckDlgButton(hDlg,IDC_CHECK1,1);
				flt_level_min=1;
				flt_length_min=1;
			}
			else  {
				CheckDlgButton(hDlg,IDC_CHECK1,0);
				flt_level_min=20;
				flt_length_min=300;
			}
			SetDlgItemInt(hDlg,IDC_EDIT3,flt_level_min,FALSE);
			SetDlgItemInt(hDlg,IDC_EDIT4,flt_length_min,FALSE);
			break;
		case IDOK:
			flt_key_min=GetDlgItemInt(hDlg,IDC_EDIT1,&stat,FALSE);
			flt_key_max=GetDlgItemInt(hDlg,IDC_EDIT2,&stat,FALSE);
			flt_level_min=GetDlgItemInt(hDlg,IDC_EDIT3,&stat,FALSE);
			flt_length_min=GetDlgItemInt(hDlg,IDC_EDIT4,&stat,FALSE);
			flt_diff_level=GetDlgItemInt(hDlg,IDC_EDIT5,&stat,TRUE);
			flt_interval_max=GetDlgItemInt(hDlg,IDC_EDIT6,&stat,FALSE);
			EndDialog(hDlg,IDOK);
			break;
		}
		break;
		default:
			return(FALSE);
	}
	return(TRUE);
}

/**
* @fn Setup_NoteEdit
* @brief MIDIm[gEp[^ҏW_CAO{bNXpbZ[W nh
* @param (hDlg) Windows Dialog̃nh
* @param (message,wParam,lParam) WindowsCxgbZ[Wуp[^
* @return Ȃ
* @sa
* @detail IDD_NOTE_EDIT
*/
LRESULT CALLBACK Setup_NoteEdit(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	BOOL stat;
	char code[20];
	switch(uMsg)
	{
	case WM_INITDIALOG:
		SetDlgItemInt(hDlg,IDC_EDIT1,note_number,FALSE);
		conv_note_char(note_number,code);
		SetDlgItemText(hDlg,IDC_EDIT2,code);
		SetDlgItemInt(hDlg,IDC_EDIT3,note_time_on,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT4,note_time_off,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT5,note_time_off-note_time_on,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT6,note_velocity,FALSE);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDCANCEL:
			EndDialog(hDlg,IDCANCEL);
			break;
		case IDC_BUTTON1:
			note_number=GetDlgItemInt(hDlg,IDC_EDIT1,&stat,FALSE);
			conv_note_char(note_number,code);
			SetDlgItemText(hDlg,IDC_EDIT2,code);
			note_time_on=GetDlgItemInt(hDlg,IDC_EDIT3,&stat,FALSE);
			note_time_off=GetDlgItemInt(hDlg,IDC_EDIT4,&stat,FALSE);
			SetDlgItemInt(hDlg,IDC_EDIT5,note_time_off-note_time_on,FALSE);
			note_velocity=GetDlgItemInt(hDlg,IDC_EDIT6,&stat,FALSE);
			break;
		case IDC_BUTTON2:
			delete_midinote();
			EndDialog(hDlg,IDOK);
			break;
		case IDC_BUTTON3:
			note_number=GetDlgItemInt(hDlg,IDC_EDIT1,&stat,FALSE);
			note_time_on=GetDlgItemInt(hDlg,IDC_EDIT3,&stat,FALSE);
			note_time_off=GetDlgItemInt(hDlg,IDC_EDIT4,&stat,FALSE);
			note_velocity=GetDlgItemInt(hDlg,IDC_EDIT6,&stat,FALSE);
			update_midinote(TRUE);
			EndDialog(hDlg,IDOK);
			break;
		case IDOK:
			note_number=GetDlgItemInt(hDlg,IDC_EDIT1,&stat,FALSE);
			note_time_on=GetDlgItemInt(hDlg,IDC_EDIT3,&stat,FALSE);
			note_time_off=GetDlgItemInt(hDlg,IDC_EDIT4,&stat,FALSE);
			note_velocity=GetDlgItemInt(hDlg,IDC_EDIT6,&stat,FALSE);
			update_midinote(FALSE);
			EndDialog(hDlg,IDOK);
			break;
		}
		break;
		default:
			return(FALSE);
	}
	return(TRUE);
}

/**
* @fn Setup_Pitch
* @brief MIDIsb`Ee|ύXݒ_CAO{bNXpbZ[W nh
* @param (hDlg) Windows Dialog̃nh
* @param (message,wParam,lParam) WindowsCxgbZ[Wуp[^
* @return Ȃ
* @sa
* @detail IDD_SETUP_PITCH
*/
LRESULT CALLBACK Setup_Pitch(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	BOOL stat;
	switch(uMsg)
	{
	case WM_INITDIALOG:
		SetDlgItemInt(hDlg,IDC_EDIT1,change_pitch_value,TRUE);
		SetDlgItemInt(hDlg,IDC_EDIT2,change_tempo_value,FALSE);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDCANCEL:
			EndDialog(hDlg,IDCANCEL);
			break;
		case IDOK:
			change_pitch_value=GetDlgItemInt(hDlg,IDC_EDIT1,&stat,TRUE);
			change_tempo_value=GetDlgItemInt(hDlg,IDC_EDIT2,&stat,FALSE);
			EndDialog(hDlg,IDOK);
			break;
		}
		break;
		default:
			return(FALSE);
	}
	return(TRUE);
}

