/**
* @file FFTbase.cpp
* @brief g͊{W[
* @author T.Modegi
* @date  2023.6.26
*/
#include "StdAfx.h"
#include <stdio.h>
#include <math.h>
#include "common.h"
#include "MIDcnv_s1_fft.h"
#include "MIDfile.h"
#include "commparam.h"
#include "commdata.h"
#include "FFTbase.h"
#define PAI 3.1415926535

FFTPREV *fft_prev;
extern HWND hWnd_main;

/**
* @fn disp_progress
* @brief ̐i󋵂\
* @param (mode) \鏈ȇI
* @param (proc) \i󋵃p[Zg
* @param (lpszWAVEFileName) ĐWAVfBÃt@C
* @return Ȃ
* @sa 
* @detail eLXgR\[iob`j܂͋NWindow֕\
*/
void disp_progress(int mode,unsigned int proc)
{
	int i;
	HDC hdc;
	char mess[120];
	if (batch_mode) {
	if (mode==4)
		printf("Sinusoidal Waveform Tables : %d [%%]\r",proc);
	else if (mode==2)
		printf("Signal Processing Executing : %d [%%]\r",proc);
	}
	else {
	if (mode==4)
		sprintf(mess,"ge[u쐬F%d [%%]\n",proc);
	else if (mode==2)
		sprintf(mess,"g͏isF%d [%%]\n",proc);
	for (i=0;i<120;i++) if (mess[i]=='\n') break;
	hdc=GetDC(hWnd_main);
	SetTextColor(hdc,RGB(0,0,0));
	SetBkColor(hdc,RGB(255,255,255));
	TextOut( hdc,10,10,mess,i);
	ReleaseDC(hWnd_main,hdc);
	}
}

/**
* @fn sincos_tbl
* @brief e͎gɑ΂16bitsge[u̍쐬 
* @param () Ȃ
* @return Ȃ
* @sa disp_progress
* @detail@16bitsgE]ge[usft_sintbl,sft_costblB
*/
void sincos_tbl()
{
	int n,i,j,l;
	int p,c;
	int iang1,iang2;
	double arg;
	int tcycle;
	int ifa;
	double *tbls,*tblc,ss,sc,*stbl,*ctbl,sums,sumc;
	unsigned int per;

	tbls=(double *)malloc(32768*8);
	tblc=(double *)malloc(32768*8);
	stbl=(double *)malloc(32768*8);
	ctbl=(double *)malloc(32768*8);
	arg=2.0*PAI/32768.0;
	for (i=0;i<32768;i++) tbls[i]=16384.0*sin(arg*(double)i);
	for (i=0;i<32768;i++) tblc[i]=16384.0*cos(arg*(double)i);

	sft_sintbl=(short *)malloc(last_adr_tbl*2);
	sft_costbl=(short *)malloc(last_adr_tbl*2);
	for (n=0;n<dft_note_cnt;n++) {
		ifa=freq_adr[n];
		for (j=0;j<freq_resol[n];j++) {
			l=adr_tbl[ifa+j];
			arg=32768.0/cycle_tbl[ifa+j];
			tcycle=width_tbl[ifa+j];
			sums=sumc=0.0;
			for (i=0;i<tcycle;i++) {
				ss=sc=0.0;
				c=0;
				iang1=(int)(arg*(double)i-arg*0.25);
				if (iang1<0) iang1+=32768;
				iang2=(int)(arg*(double)i+arg*0.25);
				if (iang1>32767) iang1=iang1%32768;
				if (iang2>32767) iang2=iang2%32768;
				p=iang1;
				if (p>iang2) {
					while (p<32768) {
						ss +=tbls[p];
						sc +=tblc[p];
						c++;
						p++;
					}
					p=0;
				}
				while(p<=iang2) {
					ss +=tbls[p];
					sc +=tblc[p];
					c++;
					p++;
				}
				ss=ss/(double)c;
				sc=sc/(double)c;
				sums +=ss;
				sumc +=sc;
				stbl[i]=ss;
				ctbl[i]=sc;
			}
			sums=sums/(double)tcycle;
			sumc=sumc/(double)tcycle;
			for (i=0;i<tcycle;i++) {
				sft_sintbl[l+i]=(short)(stbl[i]-sums);
				sft_costbl[l+i]=(short)(ctbl[i]-sumc);
			}
		}
		per=(unsigned int)(ifa*100/last_freq_adr);
		disp_progress(4,per);
	}
	free(tbls);
	free(tblc);
	free(stbl);
	free(ctbl);
}

/**
* @fn set_freq_resol
* @brief em[gio[ɑ΂͎g̔\̐ݒ
* @param () Ȃ
* @return Ȃ
* @sa 
* @detail@e[ufreq_resol,freq_adrB
*/
void set_freq_resol()
{
	int i,s;
	static int tbl[46]={
	 3, 3, 3, 3, 3, 3, 3, 3, 5, 5,
	 5, 5, 5, 5, 7, 7, 7, 7, 9, 9,
	 9, 9,11,11,11,13,13,15,15,17,
	17,19,19,21,23,25,27,29,31,33,
	35,37,39,41,43,45
	};

	last_freq_adr=0;
	dft_note_cnt=0;
	for (i=key_min;i<=key_max;i++) {
		if (variable_resol) {
			if (i<freq_resol_base) s=1;
			else if (i>=freq_resol_base && i<=freq_resol_base+45) s=tbl[i-freq_resol_base];
			else if (i>freq_resol_base+45) s=freq_resol_def;
			if (s>freq_resol_def) s=freq_resol_def;
		}
		else s=freq_resol_def;
		freq_resol[dft_note_cnt]=s;
		freq_adr[dft_note_cnt]=last_freq_adr;
		dft_note_tbl[dft_note_cnt]=i;
		last_freq_adr +=s;
		dft_note_cnt++;
	}
}

/**
* @fn dft_table
* @brief em[gio[ɑ΂ĉ͂Ɏgp鐳g̎̐ݒ
* @param () Ȃ
* @return Ȃ
* @sa 
* @detail@e[ucycle_tbl,width_tbl,adr_tblB
*/
/*
void dft_table()
{
	int i,j,l,n;
	double d,fs,f;
	int tcycle;
	double fstep,fshift;
	int ifa;

	fs=(double)sample_freq;
	cycle_tbl=(double *)malloc(last_freq_adr*8);
	width_tbl=(int *)malloc(last_freq_adr*4);
	adr_tbl=(int *)malloc(last_freq_adr*4);
	last_adr_tbl=0;
	for (i=0;i<dft_note_cnt;i++) {
		if (freq_resol[i]==1)  {fshift=0.0; fstep=1.0;}
		else {
		fstep=1.0/(double)freq_resol[i];
		fshift= -0.5+fstep*0.5;
		}
		ifa=freq_adr[i];
		n=dft_note_tbl[i];

		for (l=0;l<freq_resol[i];l++) {			
			d=((double)(n-69)+fshift)/12.0;
			f=pow(2.0,d)*double(a3tuning_freq);
			cycle_tbl[ifa+l]=fs/f;
			j=(int)((double)fft_size/cycle_tbl[ifa+l]);
// ͎͑gƂɎ̐{ɂȂ悤ɉϒƂA
// ቹłfft_sizeōŒ̎̐{ɐݒ肵Ał32ŒŉϒɂB
			if (j>32) j=32;
			else if (j==0) j=1;
			tcycle=(int)((double)j*cycle_tbl[ifa+l]);
			if (tcycle>fft_size) tcycle=fft_size;
			while (tcycle<fft_step) 
			{
				j++;
				tcycle=(int)((double)j*cycle_tbl[ifa+l]);
			}
				width_tbl[ifa+l]=tcycle;
				adr_tbl[ifa+l]=last_adr_tbl;
				last_adr_tbl +=tcycle;
			fshift +=fstep;
		}
	}

	ift_work=(int *)malloc(fft_size*4);
//	amp_work=(int *)malloc(fft_size*4);
	fft_prev=(FFTPREV *)malloc(last_freq_adr*sizeof(FFTPREV));
}
*/
void dft_table()
{
	int i,j,l,n;
	double d,fs,f;
	int tcycle;
	double fstep,fshift;
	int ifa;

	fs=(double)sample_freq;
	cycle_tbl=(double *)malloc(last_freq_adr*8);
	width_tbl=(int *)malloc(last_freq_adr*4);
	adr_tbl=(int *)malloc(last_freq_adr*4);
	last_adr_tbl=0;
	for (i=0;i<dft_note_cnt;i++) {
		if (freq_resol[i]==1)  {fshift=0.0; fstep=1.0;}
		else {
		fstep=1.0/(double)freq_resol[i];
		fshift= -0.5+fstep*0.5;
		}
		ifa=freq_adr[i];
		n=dft_note_tbl[i];

		for (l=0;l<freq_resol[i];l++) {			
			d=((double)(n-69)+fshift)/12.0;
			f=pow(2.0,d)*double(a3tuning_freq);
			cycle_tbl[ifa+l]=fs/f;
			j=(int)((double)fft_size/cycle_tbl[ifa+l]);
// ͎͑gƂɎ̐{ɂȂ悤ɉϒƂA
// ቹłfft_sizeōŒ̎̐{ɐݒ肵Ał32ŒŉϒɂB
			if (j>32) j=32;
			else if (j==0) j=1;
			tcycle=(int)((double)j*cycle_tbl[ifa+l]);
			if (tcycle>fft_size) tcycle=fft_size;
			while (tcycle<fft_step) 
			{
				j++;
				tcycle=(int)((double)j*cycle_tbl[ifa+l]);
			}
				width_tbl[ifa+l]=tcycle;
				adr_tbl[ifa+l]=last_adr_tbl;
				last_adr_tbl +=tcycle;
			fshift +=fstep;

//			if (l==freq_resol[i]/2) note_interval[i]=tcycle;
			if (l==freq_resol[i]/2) note_interval[n]=tcycle;
		}
	}

	ift_work=(int *)malloc(fft_size*4);
//	amp_work=(int *)malloc(fft_size*4);
	fft_prev=(FFTPREV *)malloc(last_freq_adr*sizeof(FFTPREV));
}


/**
* @fn dft_close
* @brief g͂̂߂ɐSẴe[uj
* @param () Ȃ
* @return Ȃ
* @sa 
* @detail
*/
int dft_close()
{
	free(sft_sintbl);
	free(sft_costbl);
	free(ift_work);
//	free(amp_work);
	free(cycle_tbl);
	free(width_tbl);
	free(adr_tbl);
	free(fft_prev);
	return(max_fftlevel);
}

/**
* @fn calc_correlation
* @brief MfЂƎw肳ꂽg̐gƂ̑֌vZ
* @param (im,is) m[gio[Ɣ
* @param (svo,cvo) Zo鑊֒l̃xNg
* @return ֒lXJ[
* @sa 
* @detail@͑Ώۂ̐MfЂift_workɐlŎ[B
*/
int calc_correlation(int im,int is,int *svo,int *cvo)
{
	int i;
	int l;
	int tcycle;
	int sv,cv,ev;
	int ifa;
	ifa=freq_adr[im]+is;
	if (cycle_tbl[ifa]<0.0) {
		*svo=*cvo=0;
		return(0);
	}
	tcycle=width_tbl[ifa];
	l=adr_tbl[ifa];

	sv=cv=0;
	for (i=0;i<tcycle;i++) {
		sv +=ift_work[i]*(int)sft_sintbl[l+i]/16384;
		cv +=ift_work[i]*(int)sft_costbl[l+i]/16384;
	}
	sv=sv*2/tcycle;
	cv=cv*2/tcycle;
	*svo=sv;
	*cvo=cv;
	ev=sv*sv+cv*cv;
	return ev;
}
/*
int calc_correlation(int im,int is,int *svo,int *cvo)
{
	int i;
	int l;
	int tcycle;
	int sv,cv,ev;
	int ifa;
	int d;
	ifa=freq_adr[im]+is;
	if (cycle_tbl[ifa]<0.0) {
		*svo=*cvo=0;
		return(0);
	}
	tcycle=width_tbl[ifa];
	l=adr_tbl[ifa];

	sv=cv=0;
	for (i=0;i<tcycle;i++) {
		d=ift_work[i]*amp_work[i]/16384;
		sv +=d*(int)sft_sintbl[l+i]/16384;
		cv +=d*(int)sft_costbl[l+i]/16384;
	}
	sv=sv*2/tcycle;
	cv=cv*2/tcycle;
	*svo=sv;
	*cvo=cv;
	ev=sv*sv+cv*cv;
	return ev;
}
*/

/**
* @fn calc_correlationD
* @brief MfЂw肳ꂽg̐gZiUd݊֐̍lj
* @param (im,is) m[gio[Ɣ
* @param (svo,cvo) OɎZo֒l̃xNg
* @return Ȃ
* @sa 
* @detail@ʉa͂s邽߁AZoꂽ֒lɊÂMfЂXVB
*/
void calc_correlationD(int im,int is,int sv,int cv)
{
	int i,j;
	int l;
	int tcycle;
	int ifa;
	ifa=freq_adr[im]+is;
	if (cycle_tbl[ifa]<0.0) {
		return;
	}
	tcycle=width_tbl[ifa];
	l=adr_tbl[ifa];

	j=0;
	for (i=0;i<fft_size;i++) { 
		ift_work[i] -=sv*(int)sft_sintbl[l+j]/16384+cv*(int)sft_costbl[l+j]/16384;
		j++;
		if (j>=tcycle) j=0; 
	}
}
/*
void calc_correlationD(int im,int is,int sv,int cv)
{
	int i,j;
	int l;
	int tcycle;
	int ifa;
	int d;

	ifa=freq_adr[im]+is;
	if (cycle_tbl[ifa]<0.0) {
		return;
	}
	tcycle=width_tbl[ifa];
	l=adr_tbl[ifa];

	j=0;
	for (i=0;i<fft_size;i++) { 
		d=sv*(int)sft_sintbl[l+j]/16384+cv*(int)sft_costbl[l+j]/16384;
		ift_work[i] -=d*amp_work[i]/16384;
		j++;
		if (j>=tcycle) j=0; 
	}
}
*/

/**
* @fn calc_correlationA
* @brief MfЂƎw肳ꂽg̐gƂ̑֌vZij
* @param (im,is) m[gio[Ɣ
* @param (offset)	͑Ώۂ̐MfЂ̃Tvʒu
* @param (dt1)	Ỏ̓t[Ƃ̃I[o[bvԁi炩ߑւvZς݂̃Tvj
* @param (dt2) 㑱̉̓t[ƃI[o[bvȂŐԁiTvj
* @return ֒lXJ[
* @sa 
* @detail@͑Ώۂ̐MfЂift_workɐlŎ[B
*/
int calc_correlationA(int im,int is,int offset,int dt1,int dt2,int *svo,int *cvo)
{
	int i,ii,io;
	int l;
	int tcycle;
	int sv,cv,ev;
	int sv2,cv2;
	int ifa;
	ifa=freq_adr[im]+is;
	if (cycle_tbl[ifa]<0.0) return(0);
	tcycle=width_tbl[ifa];
	l=adr_tbl[ifa];

	if (dt1>0) {
		sv=fft_prev[ifa].sv;
		cv=fft_prev[ifa].cv;
		io=tcycle-dt1;
	}
	else {
		sv=cv=0;
		io=0;
	}
	ii=(offset+io)%tcycle;
	for (i=io;i<tcycle;i++) {
		sv +=ift_work[i]*(int)sft_sintbl[l+ii]/16384;
		cv +=ift_work[i]*(int)sft_costbl[l+ii]/16384;
		ii++;
		if (ii>=tcycle)  ii=0;
	}
	fft_prev[ifa].sv=sv;
	fft_prev[ifa].cv=cv;
	sv=sv*2/tcycle;
	cv=cv*2/tcycle;
	*svo=sv;
	*cvo=cv;
	ev=sv*sv+cv*cv;

	if (dt2>0) {
		sv2=cv2=0;
		ii=offset%tcycle;
		for (i=0;i<dt2;i++) {
			sv2 +=ift_work[i]*(int)sft_sintbl[l+ii]/16384;
			cv2 +=ift_work[i]*(int)sft_costbl[l+ii]/16384;
			ii++;
			if (ii>=tcycle)  ii=0;
		}
		fft_prev[ifa].sv -=sv2;
		fft_prev[ifa].cv -=cv2;
	}

	return ev;
}

/**
* @fn ampl_weight_func
* @brief Pt[̔g`f[^ɐUdݑ֐ZoB
* @param () Ȃ
* @return Ȃ
* @sa 
* @detail@ift_workɐUd݊֐amp_workB
*/
/*
void ampl_weight_func()
{
	int i,j,n,v,vmax,pvmax;
	int step;
	double a;
	int vmmax;
	step=fft_step;
	n=fft_size/step;
	pvmax=0;
	vmmax=0;
	for (i=0;i<fft_size;i++) amp_work[i]=0;
	for (j=0;j<n;j++) {
		vmax=0;
		for (i=0;i<step;i++) {
			v=ift_work[j*step+i];
			if (v<0) v= -v;
			if (v>vmax) vmax=v;
		}
		if (vmax>vmmax) vmmax=vmax;
		if (j==0) {
			for (i=0;i<step;i++) amp_work[i]=vmax;
		}
		else {
			a=(double)(vmax-pvmax)/(double)(step-1);
			for (i=0;i<step;i++) {
				v=(int)(a*(double)i)+pvmax;
				amp_work[j*step+i]=v;
			}
		}
		pvmax=vmax;
	}
	if (vmmax>0) {
		a=16384.0/(double)vmmax;
		for (i=0;i<fft_size;i++) {
			v=amp_work[i];
			v=(int)(a*(double)v);
			if (v>16384) v=16384;
			amp_work[i]=v;
		}
	}
}
*/