/**
* @file INITfile.cpp
* @brief t@Cq^v
* @author T.Modegi
* @date  2023.6.27
*/
#include "StdAfx.h"
#include <stdio.h>
#include <Shellapi.h>
#include "resource.h"
#include "MIDfile.h"
#include "INITfile.h"
#include "common.h"
#include "commdata.h"
#include "commparam.h"

/**
* @fn Read_INITfile
* @brief t@C̓ǂݍ
* @param () Ȃ
* @return TRUE
* @sa 
* @detail@t@C"MIDIplay.ini"͎st@CƓtH_ɔzu
*/
BOOL Read_INITfile()
{
	char myname[200];
	int i,j,v;
	char myfile[256];
	char prm[8];
	for (i=0;i<200;i++) myname[i]='\0';
	GetModuleFileName(NULL,myname,200);
	for (i=199;i>=0;i--) if (myname[i]=='\\') break;
	for (j=199;j>i;j--) myname[j]='\0';
	sprintf(myfile,"%sWaveMidi.ini",myname);

	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("MIDI\0","DEVICE\0","0\0",prm,8,myfile);
	MIDI_device=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("MIDI\0","BANK1\0","0\0",prm,8,myfile);
	MIDI_bank1=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("MIDI\0","BANK2\0","0\0",prm,8,myfile);
	MIDI_bank2=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("MIDI\0","PROGRAM\0","1\0",prm,8,myfile);
	MIDI_program=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("MIDI\0","VOLUME\0","127\0",prm,8,myfile);
	MIDI_volume=atoi(prm);

	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV1\0","OVERTONE_CORRECT\0","0\0",prm,8,myfile);
	v=atoi(prm);
	if (v==1) overtone_correct=TRUE; else overtone_correct=FALSE;
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV1\0","OVERTONE_LEVEL\0","100\0",prm,8,myfile);
	overtone_level=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV1\0","FINE_NOTE\0","0\0",prm,8,myfile);
	v=atoi(prm);
	if (v==1) fine_note=TRUE; else fine_note=FALSE;

	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV1\0","FUNDAMENTAL_CORRECT\0","0\0",prm,8,myfile);
	v=atoi(prm);
	if (v==1) fundamental_correct=TRUE; else fundamental_correct=FALSE;
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV1\0","MAX_OVERTONE\0","2\0",prm,8,myfile);
	max_overtone=atoi(prm);

	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV1\0","FFT_SIZE\0","4096\0",prm,8,myfile);
	fft_size=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV1\0","VARY_RATE\0","150\0",prm,8,myfile);
	variable_rate=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV1\0","SL_DIFFLEVEL\0","10\0",prm,8,myfile);
	slice_difflevel=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV1\0","SL_DIFFNOTE\0","6\0",prm,8,myfile);
	slice_diffnote=atoi(prm);

	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV2\0","SL_INTERVAL\0","512\0",prm,8,myfile);
	slice_interval=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV2\0","VR_INTERVAL\0","1\0",prm,8,myfile);
	v=atoi(prm);
	if (v==1) variable_interval=TRUE; else variable_interval=FALSE;
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV2\0","SL_DIFFNOTE_ABS\0","8\0",prm,8,myfile);
	slice_diffnote_abs=atoi(prm);

	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV2\0","MINIMUM_LEVEL\0","5\0",prm,8,myfile);
	minimum_level=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV2\0","MAXIMUM_LEVEL\0","95\0",prm,8,myfile);
	maximum_level=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV2\0","KEY_MIN\0","21\0",prm,8,myfile);
	key_min=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV2\0","KEY_MAX\0","108\0",prm,8,myfile);
	key_max=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV2\0","SL_LENGTH\0","1\0",prm,8,myfile);
	slice_length=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV2\0","SL_LEVEL\0","1\0",prm,8,myfile);
	slice_level=atoi(prm);

	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV2\0","MAX_HARMONY\0","32\0",prm,8,myfile);
	max_harmony=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV2\0","TIME_UNIT\0","1536\0",prm,8,myfile);
	time_unit=atoi(prm);
	for (i=0;i<8;i++)  prm[i]='\0';
	GetPrivateProfileString("CONV2\0","BIT_RATE\0","9000\0",prm,8,myfile);
	max_bitrate=atoi(prm);

	return(TRUE);
}

/**
* @fn Write_INITfile
* @brief t@C̏
* @param () Ȃ
* @return TRUE
* @sa 
* @detail@t@C"MIDIplay.ini"͎st@CƓtH_ɔzu
*/
BOOL Write_INITfile()
{
	char myname[200];
	int i,j,v;
	char myfile[256];
	char prm[8];
	for (i=0;i<200;i++) myname[i]='\0';
	GetModuleFileName(NULL,myname,200);
	for (i=199;i>=0;i--) if (myname[i]=='\\') break;
	for (j=199;j>i;j--) myname[j]='\0';
	sprintf(myfile,"%sWaveMidi.ini",myname);

	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",MIDI_device);
	WritePrivateProfileString("MIDI\0","DEVICE\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",MIDI_bank1);
	WritePrivateProfileString("MIDI\0","BANK1\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",MIDI_bank2);
	WritePrivateProfileString("MIDI\0","BANK2\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",MIDI_program);
	WritePrivateProfileString("MIDI\0","PROGRAM\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",MIDI_volume);
	WritePrivateProfileString("MIDI\0","VOLUME\0",prm,myfile);

	for (i=0;i<8;i++)  prm[i]='\0';
	if (overtone_correct) v=1; else v=0;
	sprintf(prm,"%d",v);
	WritePrivateProfileString("CONV1\0","OVERTONE_CORRECT\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",overtone_level);
	WritePrivateProfileString("CONV1\0","OVERTONE_LEVEL\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	if (fine_note) v=1; else v=0;
	sprintf(prm,"%d",v);
	WritePrivateProfileString("CONV1\0","FINE_NOTE\0",prm,myfile);

	for (i=0;i<8;i++)  prm[i]='\0';
	if (fundamental_correct) v=1; else v=0;
	sprintf(prm,"%d",v);
	WritePrivateProfileString("CONV1\0","FUNDAMENTAL_CORRECT\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",max_overtone);
	WritePrivateProfileString("CONV1\0","MAX_OVERTONE\0",prm,myfile);

	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",fft_size);
	WritePrivateProfileString("CONV1\0","FFT_SIZE\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",variable_rate);
	WritePrivateProfileString("CONV1\0","VARY_RATE\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",slice_difflevel);
	WritePrivateProfileString("CONV1\0","SL_DIFFLEVEL\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",slice_diffnote);
	WritePrivateProfileString("CONV1\0","SL_DIFFNOTE\0",prm,myfile);

	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",slice_interval);
	WritePrivateProfileString("CONV2\0","SL_INTERVAL\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	if (variable_interval) v=1; else v=0;
	sprintf(prm,"%d",v);
	WritePrivateProfileString("CONV2\0","VR_INTERVAL\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",slice_diffnote_abs);
	WritePrivateProfileString("CONV2\0","SL_DIFFNOTE_ABS\0",prm,myfile);

	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",minimum_level);
	WritePrivateProfileString("CONV2\0","MINIMUM_LEVEL\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",maximum_level);
	WritePrivateProfileString("CONV2\0","MAXIMUM_LEVEL\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",key_min);
	WritePrivateProfileString("CONV2\0","KEY_MIN\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",key_max);
	WritePrivateProfileString("CONV2\0","KEY_MAX\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",slice_length);
	WritePrivateProfileString("CONV2\0","SL_LENGTH\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",slice_level);
	WritePrivateProfileString("CONV2\0","SL_LEVEL\0",prm,myfile);

	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",max_harmony);
	WritePrivateProfileString("CONV2\0","MAX_HARMONY\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",time_unit);
	WritePrivateProfileString("CONV2\0","TIME_UNIT\0",prm,myfile);
	for (i=0;i<8;i++)  prm[i]='\0';
	sprintf(prm,"%d",max_bitrate);
	WritePrivateProfileString("CONV2\0","BIT_RATE\0",prm,myfile);

	return(TRUE);
}

/**
* @fn Open_Manual
* @brief eLXg`IC}jA̋N
* @param () Ȃ
* @return Ȃ
* @sa 
* @detail@}jAEt@C"manual.txt"͎st@CƓtH_ɔzu
*/
void Open_Manual()
{
	char myname[200];
	int i,j;
	char myfile[256];
	for (i=0;i<200;i++) myname[i]='\0';
	GetModuleFileName(NULL,myname,200);
	for (i=199;i>=0;i--) if (myname[i]=='\\') break;
	for (j=199;j>i;j--) myname[j]='\0';
	sprintf(myfile,"%smanual.txt",myname);
	ShellExecute(NULL,"open",myfile,"","",1);
}
