/**
* @file MCI_proc.cpp
* @brief MCI-window(Media Control Interface)pWAVt@CĐW[
* @author T.Modegi
* @date  2019.1.21
*/
#include "stdafx.h"
#include <vfw.h>
#include "MCI_proc.h"
#include "common.h"
#include "commdata.h"

HWND hMCIWnd=NULL;
BOOL play_status=FALSE;

/**
* @fn playMCIFile
* @brief MCIWnd`WAVfBAv[NĐJn
* @param (hInst) NWindowCX^X̃nh
* @param (hWndNotify) bZ[WԂWindow̃nh
* @param (lpszWAVEFileName) ĐWAVfBÃt@C
* @return 0
* @sa 
* @detail@NWindowɍĐio[dzu
*/
DWORD playMCIFile(HINSTANCE hInst,HWND hWndNotify,LPSTR lpszWAVEFileName)
{
	HWND MainWnd=NULL;
	int px,py,sx,sy;
	RECT  rect;

	MainWnd=GetActiveWindow();
	GetWindowRect(MainWnd,&rect);
	hMCIWnd=MCIWndCreate(hWndNotify,hInst,
		WS_VISIBLE | WS_OVERLAPPEDWINDOW |
		WS_BORDER | MCIWNDF_SHOWALL | MCIWNDF_NOTIFYMODE,
		NULL);
	MCIWndSetTimers(hMCIWnd,100,100);
	px=rect.left;  py=rect.top+40;
	sx=rect.right-rect.left; sy=50;
	MoveWindow(hMCIWnd,px,py,sx,sy,true);
    MCIWndOpen(hMCIWnd, lpszWAVEFileName, NULL);
    MCIWndPlay(hMCIWnd);
	play_status=TRUE;
	return 0;
}

/**
* @fn stopMCIFile
* @brief ĐMCIWnd`WAVfBAv[~Ej
* @param () Ȃ
* @return Đ|WV
* @sa 
* @detail
*/
int stopMCIFile()
{
	int tt=MCIWndGetPosition(hMCIWnd);
	if (play_status) {
		MCIWndClose(hMCIWnd);
		MCIWndDestroy(hMCIWnd);
		play_status=FALSE;
	}
	return(tt);
}

/**
* @fn InquirePlayerStatus
* @brief ĐMCIWnd`WAVfBAv[̏ԂmFA~Ă̏ꍇ͔j
* @param () Ȃ
* @return Đ
* @sa stopMCIFile
* @detail
*/
BOOL InquirePlayerStatus()
{
	char buff[20];
	if (play_status) {
		if (MCIWndGetMode(hMCIWnd,buff,20)==MCI_MODE_STOP)
			stopMCIFile();
	}
	return(play_status);
}
