/**
* @file MIDcnv_main.cpp
* @brief MIDI@C
* @author T.Modegi
* @date  2019.1.22
*/
#include "StdAfx.h"
#include "common.h"
#include "commparam.h"
#include "MIDfile.h"
#include "MIDdraw.h"
#include "MIDcnv_s1_fft.h"
#include "MIDcnv_s2_sec.h"
#include "MIDcnv_s3_enc.h"
#include "MIDcnv_s4_mid.h"
#include "MIDcnv_main.h"
#include "commdata.h"

extern HANDLE hThread;
extern HWND hWnd_main;

/**
* @fn wav_channel_proc
* @brief XeIMmɕύX
* @param () Ȃ
* @return Ȃ
* @sa 
* @detail
*/
void wav_channel_proc()
{
	int i;

	if (wav_channel==2) {
		for (i=0;i<num_sample;i++) wavbuf[i]=(wavbuf[i*2]+wavbuf[i*2+1])/2;
		wav_channel=1;
	}
}

/**
* @fn fMIDcnv_main
* @brief MIDIC
* @param () Ȃ
* @return ꂽMIDICxg
* @sa wav_channel_proc,fMIDcnv_s1_fft,fMIDcnv_s2_sec,fMIDcnv_s3_enc,adjust_bitrate,count_harmony
* @detail
*/
int fMIDcnv_main()
{
	if (!recalc_mode) {wav_channel_proc(); fMIDcnv_s1_fft();}
	if (fMIDcnv_s2_sec()<=0) return(0);
	abs_time=fMIDcnv_s3_enc();

	abs_time=MidiMsg[song_len-1].ms;
	total_time=MidiMsg[song_len-1].ms*1000/time_unit;
	if (max_bitrate>0) {
		song_len=adjust_bitrate();
		abs_time=MidiMsg[song_len-1].ms;
		total_time=MidiMsg[song_len-1].ms*1000/time_unit;
	}
	cur_harmony=count_harmony();
	return(song_len);
}

/**
* @fn fMIDcnv_thread
* @brief MIDICiXbhNŁj
* @param () Ȃ
* @return Ȃ
* @sa wav_channel_proc,fMIDcnv_s1_fft,fMIDcnv_s2_sec,fMIDcnv_s3_enc,adjust_bitrate,count_harmony
* @detail
*/
void fMIDcnv_thread()
{
	if (!recalc_mode) {wav_channel_proc(); fMIDcnv_s1_fft();}

	if (fMIDcnv_s2_sec()<=0) return;
	abs_time=fMIDcnv_s3_enc();
	
	abs_time=MidiMsg[song_len-1].ms;
	total_time=MidiMsg[song_len-1].ms*1000/time_unit;
	if (max_bitrate>0) {
		song_len=adjust_bitrate();
		abs_time=MidiMsg[song_len-1].ms;
		total_time=MidiMsg[song_len-1].ms*1000/time_unit;
	}
	cur_harmony=count_harmony();
	file_mode=2;
	hThread=NULL;
	InvalidateRect(hWnd_main, 0, TRUE);
	ExitThread(0);
}
