/**
* @file MIDcnv_s2_sec.cpp
* @brief MIDI@TuQ@fԎA
* @author T.Modegi
* @date  2024.4.24
*/
#include "StdAfx.h"
#include <stdio.h>
#include "common.h"
#include "MIDcnv_s2_sec.h"
#include "commparam.h"
#include "commdata.h"
#include "MIDfile.h"

int pre_sectbl[256];

/**
* @fn correct_overtone
* @brief ff[^\̂̃Rs[siSIGWAV`j
* @param (sc) \[Xf[^\
* @param (dt) ^[Qbgf[^\
* @return Ȃ
* @sa 
* @detail
*/
void copy_section(SIGMID *sc,SIGMID *dt)
{
		dt->pos=sc->pos;
		dt->length=sc->length;
        dt->level=sc->level;
        dt->note=sc->note;
}

/**
* @fn correct_overtoneT
* @brief ff[^\̂̃Rs[siSIGWAVT`j
* @param (sc) \[Xf[^\
* @param (dt) ^[Qbgf[^\
* @return Ȃ
* @sa 
* @detail
*/
void copy_sectionT(SIGMIDT *sc,SIGMIDT *dt)
{
		dt->pos=sc->pos;
        dt->level=sc->level;
        dt->note=sc->note;
        dt->adr=sc->adr;
}

/**
* @fn load_note_interval
* @brief note_interval[]zFFTt@Cǂݍ
* @param (*fp) ǂݍFFTeLXg`t@C̃t@C|C^ 
* @return Ȃ
* @sa 
* @detail
*/
void load_note_interval(FILE *fp)
{
	int i,v;
	fscanf(fp,"%d\n",&v);
	if (v==1) variable_interval=TRUE; else variable_interval=FALSE;
	for (i=0;i<16;i++) {
		fscanf(fp,"%d %d %d %d %d %d %d %d\n",
		    &note_interval[i*8],&note_interval[i*8+1],&note_interval[i*8+2],&note_interval[i*8+3],
		    &note_interval[i*8+4],&note_interval[i*8+5],&note_interval[i*8+6],&note_interval[i*8+7]);
	}
}

/**
* @fn count_record_file
* @brief FFT`g̓f[^̃eLXgt@C艹ff[^JEg
* @param () Ȃ
* @return ff[^
* @sa 
* @detail čőMxZo
*/
int count_record_file()
{
	int i,j;
	int p,p2,p3;
	int cnt,pos,note,sub,level,conn;
	int len;
	FILE *fft_fd;

	Change_FileExt(filename,filename2,"fft");
	fft_fd=fopen(filename2,"r");
	if (fft_fd==NULL) return(0);
	fscanf(fft_fd,"%d %d %d\n",&p,&p2,&p3);
	load_note_interval(fft_fd);
	max_fftlevel=0;
	i=0;
	while(fscanf(fft_fd,"%d %ld %d\n",&cnt,&pos,&len)!=EOF)  {
		for (j=0;j<cnt;j++) {
			fscanf(fft_fd,"%d %d %d %d\n",&note,&sub,&level,&conn);
			if (level>max_fftlevel)  max_fftlevel=level;
		}
		i +=cnt;
	}
	fclose(fft_fd);
	return(i);
}

/**
* @fn convert_Cmajor
* @brief g͂ꂽff[^̃m[gio[w肳ꂽKɂȂ悤ɉς
* @param (ct) ff[^
* @param (nt) ef̃m[gio[
* @param (sub) ef̔׃m[gio[
* @param (ev) ef̋x
* @param (cn) ef̘A
* @return XVꂽff[^
* @sa 
* @detail key_noteɊÂ艹Ko
*/
int convert_Cmajor(int cnt,int nt[],int sub[],int ev[],int cn[])
{
	int i,j;
	int note;
	int n,dn1,dn2,n1,n2;
	BOOL f1,f2;

	for (i=0;i<cnt;i++) {
		if (nt[i]>=128) {note=(nt[i]-128)%12; n=nt[i]-128;}
		else {note=nt[i]%12; n=nt[i];}
		if (!key_note[note]) {
			dn1=dn2=1;
			f1=f2=FALSE;
			while (n+dn1<=key_max && dn1<12) {
				n1=note+dn1; if (n1>11)  n1 -=12;
				if (key_note[n1]) {f1=TRUE; break;}
				dn1++;
			}
			while (n-dn2>=key_min && dn2<12) {
				n2=note-dn2; if (n2<0)  n2 +=12;
				if (key_note[n2]) {f2=TRUE; break;}
				dn2++;
			}
			if (f1==TRUE && f2==TRUE && dn1==dn2) {
				if (sub[i]<freq_resol_def/2) nt[i] -=dn1;
				else nt[i] +=dn1;
			}
			else if (f1==TRUE && f2==TRUE) {
				if (dn1<dn2) nt[i] +=dn1;
				else nt[i] -=dn2;
			}
			else if (f1) nt[i] +=dn1;
			else if (f2) nt[i] -=dn2;
		}
	}

	for (i=0;i<cnt;i++) {
		if (nt[i]>=0) {
		for (j=i+1;j<cnt;j++) {
			if (nt[j]>=0 && nt[j]==nt[i]) {
				if (ev[j]>ev[i]) {
					ev[i]=ev[j];
					sub[i]=sub[j];
					cn[i]=cn[j];
				}
				nt[j]= -1;
			}
		}
		}
	}

	j=0;
	for (i=0;i<cnt;i++) {
		nt[j]=nt[i];
		ev[j]=ev[i];
		sub[j]=sub[i];
		cn[j]=cn[i];
		if (nt[j]>=0) j++;
	}
	return(j);
}

/**
* @fn adjust_note_number
* @brief g͂ꂽeff[^ɑ΂ĘA̔s
* @param (cnt) ̓t[ɂ鉹ff[^
* @param (pos) ̓t[̃|WViTvʒuj
* @param (note) ef̃m[gio[
* @param (sub) ef̔׃m[gio[
* @param (level) ef̋x
* @param (conn) ef̘A
* @param (stat) 肳ꂽef̘A
* @return Ȃ
* @sa 
* @detail
*/
/*
void adjust_note_number(int cnt,int pos,int note[],int sub[],int level[],int conn[],int stat[])
{
	int i,n,p;
	int noteh;
	int dt;
	int dn;

	for (i=0;i<cnt;i++) {
		n=note[i];
		if (n>=key_min && n<=key_max && level[i]>=slice_level) {
			stat[i]= -1;
			noteh=n*freq_resol_def+sub[i];
			if (sec_connect_off==FALSE && pre_sectbl[n]>=0) {
				p=pre_sectbl[n];
				dt=pos-sigbuf[p].pos-sigbuf[p].length;
				if (dt<slice_interval) {
					dn=noteh-sigbuf[p].note;
					if (dn<0) dn= -dn;
					if (conn[i]==1 && dn<=slice_diffnote_abs)  stat[i]=1;
				}
				else pre_sectbl[n]= -1;
			}
			if (sec_connect_off==FALSE && n>key_min) {
			if (pre_sectbl[n-1]>=0) {
				p=pre_sectbl[n-1];
				dt=pos-sigbuf[p].pos-sigbuf[p].length;
				if (dt<slice_interval) {
					dn=noteh-sigbuf[p].note;
					if (dn<0) dn= -dn;
					if (conn[i]==2 && dn<=slice_diffnote_abs)  stat[i]=2;
				}
			}
			}
			if (sec_connect_off==FALSE && n<key_max) {
			if (pre_sectbl[n+1]>=0) {
				p=pre_sectbl[n+1];
				dt=pos-sigbuf[p].pos-sigbuf[p].length;
				if (dt<slice_interval) {
					dn=noteh-sigbuf[p].note;
					if (dn<0) dn= -dn;
					if (conn[i]==3 && dn<=slice_diffnote_abs)  stat[i]=3;
				}
			}
			}
		}
		else stat[i]= -2;
	}

	if (sec_connect_off)  return;
////// frequency edge process

	for (i=0;i<cnt;i++) {
		if (stat[i]==1 && i>0) {
			if (stat[i-1]==3) stat[i-1]= -2;
		}
		if (stat[i]==1 && i<cnt-1) {
			if (stat[i+1]==2) stat[i+1]= -2;
		}
	}
}
*/
void adjust_note_number(int cnt,int pos,int note[],int sub[],int level[],int conn[],int stat[])
{
	int i,n,p;
	int noteh;
	int dt;
	int dn;
	int interval;

	for (i=0;i<cnt;i++) {
		n=note[i];
		if (n>=key_min && n<=key_max && level[i]>=slice_level) {
			stat[i]= -1;
			noteh=n*freq_resol_def+sub[i];
			if (variable_interval)	interval=note_interval[n]*slice_interval/128;
			else  interval=slice_interval;

			if (sec_connect_off==FALSE && pre_sectbl[n]>=0) {
				p=pre_sectbl[n];
				dt=pos-sigbuf[p].pos-sigbuf[p].length;
//				if (dt<slice_interval) {
				if (dt<interval) {
					dn=noteh-sigbuf[p].note;
					if (dn<0) dn= -dn;
					if (conn[i]==1 && dn<=slice_diffnote_abs)  stat[i]=1;
				}
				else pre_sectbl[n]= -1;
			}
			if (sec_connect_off==FALSE && n>key_min) {
			if (pre_sectbl[n-1]>=0) {
				p=pre_sectbl[n-1];
				dt=pos-sigbuf[p].pos-sigbuf[p].length;
//				if (dt<slice_interval) {
				if (dt<interval) {
					dn=noteh-sigbuf[p].note;
					if (dn<0) dn= -dn;
					if (conn[i]==2 && dn<=slice_diffnote_abs)  stat[i]=2;
				}
			}
			}
			if (sec_connect_off==FALSE && n<key_max) {
			if (pre_sectbl[n+1]>=0) {
				p=pre_sectbl[n+1];
				dt=pos-sigbuf[p].pos-sigbuf[p].length;
//				if (dt<slice_interval) {
				if (dt<interval) {
					dn=noteh-sigbuf[p].note;
					if (dn<0) dn= -dn;
					if (conn[i]==3 && dn<=slice_diffnote_abs)  stat[i]=3;
				}
			}
			}
		}
		else stat[i]= -2;
	}

	if (sec_connect_off)  return;
////// frequency edge process

	for (i=0;i<cnt;i++) {
		if (stat[i]==1 && i>0) {
			if (stat[i-1]==3) stat[i-1]= -2;
		}
		if (stat[i]==1 && i<cnt-1) {
			if (stat[i+1]==2) stat[i+1]= -2;
		}
	}
}

/**
* @fn connect_section
* @brief g͂ꂽẢff[^ɑ΂ԎɘAs
* @param () Ȃ
* @return Ȃ
* @sa count_record_file,Read_ConvLevel,Write_ConvLevel,convert_Cmajor,adjust_note_number
* @detail
*/
void connect_section()
{ 
	int i,j;
	int p;
	int cnt,num;
	int ii,cnt2;
	int cnto;
	int pos,length;
	int note,sub,level;
	int noteo;
	int noteh;
	int lmax,lmin;
	int anote[256],asub[256],alevel[256],stat[256],aconn[256];
	FILE *fft_fd;

	if (recalc_mode)  num_record=count_record_file();
	Change_FileExt(filename,filename2,"fft");
	fft_fd=fopen(filename2,"r");
	fscanf(fft_fd,"%d %d %d\n",&p,&slice_difflevel,&slice_diffnote);
	if (p==1) fine_note=TRUE; else fine_note=FALSE;
	load_note_interval(fft_fd);

	if (num_record<=0) return;
	sigbuf=(SIGMID *)malloc(num_record*sizeof(SIGMID));
	if (fine_note) {
		finbuf=(SIGMIDT *)malloc(num_record*sizeof(SIGMIDT));
		num_finbuf=0;
	}

	num=num_record;
	num_record=0;
	for (i=0;i<256;i++) pre_sectbl[i]= -1;

	lmin=max_fftlevel*minimum_level/100;
	lmax=(max_fftlevel-lmin)*maximum_level/100;

	i=0;
	while (i<num) {
 		fscanf(fft_fd,"%d %ld %d\n",&cnt,&pos,&length);
		for (j=0;j<cnt;j++)
  			fscanf(fft_fd,"%d %d %d %d\n",&anote[j],&asub[j],&alevel[j],&aconn[j]);
		cnto=cnt;
		if (Cmajor_key) 
			cnt=convert_Cmajor(cnt,anote,asub,alevel,aconn);
		ii=0;
		for (j=0;j<cnt;j++) {
			alevel[j]=(alevel[j]-lmin)*128/lmax;
			if (alevel[j]>127)  alevel[j]=127;
			if (alevel[j]<0)  alevel[j]=0;
				alevel[ii]=alevel[j];
				anote[ii]=anote[j];
				asub[ii]=asub[j];
				aconn[ii]=aconn[j];
				if (alevel[ii]>0)	ii++;			
		}
		cnt2=ii;
		adjust_note_number(cnt2,pos,anote,asub,alevel,aconn,stat);

		for (j=0;j<cnt2;j++) {
			if (stat[j]> -2) {
				noteo=anote[j];
				sub=asub[j];
				level=alevel[j];
				noteh=noteo*freq_resol_def+sub;
				if (stat[j]>=0) {
					note=noteo;
					if (stat[j]==2) note--;
					else if (stat[j]==3) note++;
					p=pre_sectbl[note];

					if (pos>sigbuf[p].pos) {
					sigbuf[p].length=(int)((double)pos+(double)length-(double)sigbuf[p].pos-1.0);
					if (level>sigbuf[p].level) {
						sigbuf[p].level=level;
						sigbuf[p].note=noteh;
					}
						if (fine_note) {
							finbuf[num_finbuf].adr=p;
							finbuf[num_finbuf].level=level;
							finbuf[num_finbuf].note=noteh;
							finbuf[num_finbuf].pos=pos;
							num_finbuf++;
						}

					}
				}
				else {
					sigbuf[num_record].pos=pos;
					sigbuf[num_record].note=noteh;
					sigbuf[num_record].length=length;
					sigbuf[num_record].level=level;					
					pre_sectbl[noteo]=num_record;
						if (fine_note) {
							finbuf[num_finbuf].adr=num_record;
							finbuf[num_finbuf].level=level;
							finbuf[num_finbuf].note=noteh;
							finbuf[num_finbuf].pos=pos;
							num_finbuf++;
						}
					
					num_record++;
				}
			}
		}
		i +=cnto;
	}

	fclose(fft_fd);
	if (!fft_file_out) DeleteFile(filename2);
}

/**
* @fn adjust_overlap
* @brief ԎŏdĂ鉹ff[^̒s
* @param () Ȃ
* @return Ȃ
* @sa 
* @detail őamax_harmonyɐ
*/
void adjust_overlap()
{
	int i,j,note,ir;
	int pos[256];
	int mh;
	int vmin,im,vp;
	int oct;

	for (i=0;i<256;i++) pos[i]= -1;
	for (i=0;i<num_record;i++) {
		mh=0;
		for (j=0;j<256;j++) {
			if (pos[j]>=0) {
				ir=pos[j];
				if (sigbuf[i].pos>=sigbuf[ir].pos+sigbuf[ir].length) pos[j]= -1;
				else mh++;
			}
		}
		if (sigbuf[i].note>=0 && sigbuf[i].level>=slice_level && sigbuf[i].length>=slice_length) {
			note=sigbuf[i].note/freq_resol_def;
			if (pos[note]>=0) {
				ir=pos[note];
				if (sigbuf[i].level>sigbuf[ir].level) {
					sigbuf[ir].length=sigbuf[i].pos-sigbuf[ir].pos-1;
					if (sigbuf[ir].length<=0)  sigbuf[ir].note= -1;
					pos[note]=i;
				}
				else {
					sigbuf[ir].length+=sigbuf[i].length;
					sigbuf[i].note= -1;
				}
			}
			else {
				pos[note]=i;
				mh++;
			}

			if (sigbuf[i].note>=0 && mh>max_harmony) {
				vmin= -1;
				im= -1;
				oct=0;
				for (j=0;j<256;j++) {
					if (pos[j]>=0 && pos[j]!=i) {
						ir=pos[j];
						vp=sigbuf[ir].level*sigbuf[ir].length;
						if (im== -1 || vp<vmin) { im=j; vmin=vp; }
						if (j==note-12 || j==note-19 || j==note-24 || j==note-28 || j==note-31 || j==note-34 || j==note-36) 
							oct= -1;
					}
				}
				if (im>=0) {
					ir=pos[im];
				if ((oct<0 && sigbuf[i].level*sigbuf[i].length<sigbuf[ir].level*sigbuf[ir].length*2) || 
					sigbuf[i].level*sigbuf[i].length<sigbuf[ir].level*sigbuf[ir].length/3 ||
					sigbuf[i].level<sigbuf[ir].level/2) {
					sigbuf[i].note= -1;
					pos[note]= -1;
					mh--;
				}
				else {
					sigbuf[ir].length=sigbuf[i].pos-sigbuf[ir].pos-1;
					if (sigbuf[ir].length<=0)  sigbuf[ir].note= -1;
					pos[im]= -1;
					mh--;
				}
				}
			}
		}
		else sigbuf[i].note= -1;
	}
}

/**
* @fn fMIDcnv_s2_sec
* @brief ff[^ԎɘA鏈siCj
* @param () Ȃ
* @return Ȃ
* @sa connect_section,adjust_overlap
* @detail IvVwɂs
*/
int fMIDcnv_s2_sec()
{ 
	int i,j,k;
	int *tbl;

	connect_section();
	adjust_overlap();

// Level & time Adjust
// Remove Short-length & Low-level sections
	if (fine_note) tbl=(int *)malloc(num_record*4);

	j=0;
	for (i=0;i<num_record;i++) {
		if (fine_note) tbl[i]= -1;
		if (sigbuf[i].note>=0) {
			copy_section(&sigbuf[i],&sigbuf[j]);
			sigbuf[j].pos=(int)((double)sigbuf[j].pos*(double)time_unit/(double)sample_freq);
			sigbuf[j].length=sigbuf[j].length*time_unit/sample_freq;
			if (sigbuf[j].length>=slice_length && sigbuf[j].level>=slice_level) {
				if (fine_note) tbl[i]=j;
				j++;
			}
		}
	}
	num_record=j;

	if  (fine_note) {
		j=0;
		for (i=0;i<num_finbuf;i++) {
			k=finbuf[i].adr;
			finbuf[i].adr=tbl[k];
			if (finbuf[i].adr>=0) {
				copy_sectionT(&finbuf[i],&finbuf[j]);
				finbuf[j].pos=(int)((double)finbuf[j].pos*(double)time_unit/(double)sample_freq);
				j++;
			}
		}
		num_finbuf=j;
		free(tbl);
	}

	return(num_record);
}
