/**
* @file MIDcnv_s3_enc.cpp
* @brief MIDI@TuR@MIDICxg
* @author T.Modegi
* @date  2020.8.14
*/
#include "StdAfx.h"
#include "common.h"
#include "MIDcnv_s3_enc.h"
#include "MIDfile.h"
#include "commparam.h"
#include "commdata.h"
#define MAX_HARMONY 128

int current_time=0;
int error_state=0;
int num_offbuff=0;
OFFBUF *offbuff;
OFFBUF *offbuff2;
BOOL offbuff_state;

int channel_stat[16];
int cur_channel;
int cur_finbuf;

/**
* @fn assign_channel
* @brief eff[^ɖgpMIDI`l蓖Ăij
* @param () Ȃ
* @return Ȃ
* @sa 
* @detail
*/
int assign_channel()
{
	int i,c;
	c=0;
	for (i=0;i<max_harmony+1;i++) {
		if (i!=9 && channel_stat[i]== -1)  {c=i; break;}
	}
	if (c>=0) channel_stat[c]=1;
	cur_channel=c;
	if (cur_channel>max_channel-1)  max_channel=cur_channel+1;
	return(c);
}

/**
* @fn Write_ASCexpress
* @brief R[hMIDICxg`ɕ
* @param (chan) MIDI`l
* @param (dn) ׃m[gio[iMIDIsb`xhj
* @param (at) Cxg̉tiΎj
* @param (dv) xiMIDIGNXbVj
* @return Ȃ
* @sa Write_ASCexpress
* @detail ꂽCxgMidiMsgzɎ[
*/
void Write_ASCexpress(int chan,int dn,int at,int dv)
{
	int com;
	int t,bend,bl,bh,e;
	if (chan<0 || chan>15)  return;
	t=at;

// pitch bend
	if (fine_pitchbend) {
	com=0xe0+chan;
	bend=dn*4096/freq_resol_def+8192;
//	if (bend>8191) bend=8191;
	if (bend>16383) bend=16383;
	if (bend<0) bend=0;
	bh=bend/128;
	bl=bend-bh*128;
	MidiMsg[song_len].ms=t;
	MidiMsg[song_len].com=com; MidiMsg[song_len].note=bl; MidiMsg[song_len].vel=bh; MidiMsg[song_len].chan=0;

	song_len++;
	}

// expression
	if (fine_expression) {
	com=0xb0+chan;
	e=0x0b;
	MidiMsg[song_len].ms=t;
	MidiMsg[song_len].com=com; MidiMsg[song_len].note=e; MidiMsg[song_len].vel=dv; MidiMsg[song_len].chan=0;
	song_len++;
	}
	current_time=at;
}

/**
* @fn Write_ASCnote
* @brief MIDICxg`ɕ
* @param (chan) MIDI`l
* @param (noteo) MIDIm[gio[
* @param (at) Cxg̉tiΎj
* @param (vel) MIDIxVeB
* @return Ȃ
* @sa Write_ASCexpress
* @detail ꂽCxgMidiMsgzɎ[
*/
void Write_ASCnote(int chan,int noteo,int at,int vel)
{
	int com;
	int t;
	int note;
	int adr,dn,dv;

	if (fine_note==TRUE && wav_channel==1) {
	if (cur_finbuf<num_finbuf) {
		while (finbuf[cur_finbuf].pos<at) {
			adr=finbuf[cur_finbuf].adr;
			note=sigbuf[adr].note/freq_resol_def;
			dn=finbuf[cur_finbuf].note-note*freq_resol_def-freq_resol_def/2;
			dv=127+finbuf[cur_finbuf].level-sigbuf[adr].level;
			if (dv>127) dv=127;
			if (dv<1) dv=1;
			Write_ASCexpress(chan,dn,finbuf[cur_finbuf].pos,dv);
			cur_finbuf++;
			if (cur_finbuf>=num_finbuf) break;
		}
	}
	}
	t=at;
	note=noteo;

	if (vel>0) {
		com=0x90+chan;
		MidiMsg[song_len].com=com; MidiMsg[song_len].note=note; MidiMsg[song_len].vel=vel;
	}
	else {
		com=0x80+chan;
		MidiMsg[song_len].com=com; MidiMsg[song_len].note=note; MidiMsg[song_len].vel=0;
	}
	MidiMsg[song_len].ms=t;
	MidiMsg[song_len].chan=chan;
	song_len++;
	current_time=at;
}

/**
* @fn decrease_offbuff_string
* @brief obt@̐擪̃CxgMIDICxg`ɕAobt@PCxg
* @param () Ȃ
* @return Ȃ
* @sa Write_ASCnote
* @detail ꂽCxgoffbuffzɎ[Ă
*/
void decrease_offbuff_string()
{
//	int dd;
	int i;
	int ch;

// Output First Note Off
	i=0;
	Write_ASCnote(offbuff[i].chan,offbuff[i].note,offbuff[i].pos,offbuff[i].level);
				if (fine_note) {
					ch=offbuff[i].chan;
					channel_stat[ch]= -1;
				}

// decrease Note Off buffer
	for (i=1;i<num_offbuff;i++) {
		offbuff[i-1].pos=offbuff[i].pos;
		offbuff[i-1].note=offbuff[i].note;
		offbuff[i-1].level=offbuff[i].level;
		offbuff[i-1].chan=offbuff[i].chan;
	}
	num_offbuff--;
}

/**
* @fn write_MIDInote_string
* @brief ff[^Q̃m[gI^m[gItMIDICxg`ɕ
* @param (ptime) f̉t
* @param (dtime) f̎
* @param (number) f̃m[gio[i׃m[gio[܂ށj
* @param (velocity) f̃xVeB
* @return Ȃ
* @sa Write_ASCnote,assign_channel,decrease_offbuff_string
* @detail ꂽCxgoffbuff,offbuff2zɎ[
*/
void write_MIDInote_string(int ptime,int dtime,int number,int velocity)
{
	int i,c;
	int num;
	int chan;
	int note;

// Output Note Off
	note=number/freq_resol_def;

	if (num_offbuff>0) {
		for (i=0;i<num_offbuff;i++) {
			offbuff2[i].pos=offbuff[i].pos;
			offbuff2[i].note=offbuff[i].note;
			offbuff2[i].level=offbuff[i].level;
			offbuff2[i].chan=offbuff[i].chan;
		}
		c=0;
		for (i=0;i<num_offbuff;i++) {
			if (offbuff[i].pos<=ptime) {
				Write_ASCnote(offbuff[i].chan,offbuff[i].note,offbuff[i].pos,offbuff[i].level);
				offbuff2[i].note= -1;
				if (fine_note) {
					chan=offbuff[i].chan;
					channel_stat[chan]= -1;
				}
				c++;
			}
		}
		if (c>0) {
			num=num_offbuff;
			num_offbuff=0;
			for (i=0;i<num;i++) {
				if (offbuff2[i].note>=0) {
					offbuff[num_offbuff].note=offbuff2[i].note;
					offbuff[num_offbuff].pos=offbuff2[i].pos;
					offbuff[num_offbuff].level=offbuff2[i].level;
					offbuff[num_offbuff].chan=offbuff2[i].chan;
					num_offbuff++;
				}
			}
		}
	}

// Output Note-On and Add-Note Off Buffer
		if (fine_note) chan=assign_channel();  else chan=0;
		Write_ASCnote(chan,note,ptime,velocity);
		offbuff[num_offbuff].pos=ptime+dtime;
		offbuff[num_offbuff].note=note;
		offbuff[num_offbuff].level=0;
		offbuff[num_offbuff].chan=chan;
		num_offbuff++;
		if (num_offbuff>=MAX_HARMONY) {
			decrease_offbuff_string();
			if (offbuff_state==FALSE) {
				MessageBox(NULL,"MIDIm[gItEobt@TCY𒴂܂B",
				"MIDIo̓t@CG[",MB_OK);
				offbuff_state=TRUE;
			}
		}
}

/**
* @fn close_offbuff_string
* @brief obt@ɕۑĂSẴCxgMIDICxg`ɕAobt@NAɂ
* @param () Ȃ
* @return Ȃ
* @sa Write_ASCnote
* @detail ꂽCxgoffbuffzɎ[Ă
*/
void close_offbuff_string()
{
	int i;

// Output Note Off
	if (num_offbuff>0) {
	  for (i=0;i<num_offbuff;i++) {
			Write_ASCnote(offbuff[i].chan,offbuff[i].note,offbuff[i].pos,offbuff[i].level);
	  }
	}
	num_offbuff=0;
}


/**
* @fn fMIDcnv_s3_enc
* @brief Ảff[^MIDICxg`ɕiCj
* @param () Ȃ
* @return Ȃ
* @sa write_MIDInote_string,close_offbuff_string
* @detail ꂽCxgMidiMsgzɎ[
*/
int fMIDcnv_s3_enc()
{
	int i;
	offbuff=(OFFBUF *)malloc(MAX_HARMONY*sizeof(OFFBUF));
	offbuff2=(OFFBUF *)malloc(MAX_HARMONY*sizeof(OFFBUF));

	offbuff_state=FALSE;
	error_state=0;
	if (song_len>0) free(MidiMsg);
	if (fine_note) {
	MidiMsg=(MIDIMSG *)malloc((num_record*2+num_finbuf*2)*sizeof(MIDIMSG));
	}
	else {
	MidiMsg=(MIDIMSG *)malloc(num_record*2*sizeof(MIDIMSG));
	}

	max_channel=1;
	if (fine_note) {
		for (i=0;i<16;i++)  channel_stat[i]= -1;
	}
	song_len=0;

	num_offbuff=0;
	current_time=0;
	cur_finbuf=0;
	for (i=0;i<num_record;i++) {
		write_MIDInote_string(sigbuf[i].pos,sigbuf[i].length,sigbuf[i].note,sigbuf[i].level);
	}

	close_offbuff_string();
	
		if (fine_note) {
			free(finbuf);
			num_finbuf=0;
		}
	free(sigbuf);
	num_record=0;
	free(offbuff);
	free(offbuff2);

	return(current_time);
}

