/**
* @file MIDdialog.cpp
* @brief p[^ݒpWindows_CAÕnh[i\,MIDItAMIDIϊj
* @author T.Modegi
* @date  2024.3.14
*/
#include "stdafx.h"
#include <commdlg.h>
#include <math.h>
#include "resource.h"
#include "common.h"
#include "commparam.h"
#include "INITfile.h"
#include "MIDout.h"
#include "MIDdialog.h"
#include "MIDfile.h"
#include "MIDedit.h"
#include "commdata.h"

extern HINSTANCE hInst;					// ݂̃CX^X
int sel_program=0;

/**
* @fn About
* @brief o[W{bNXpbZ[W nh
* @param (hDlg) Windows Dialog̃nh
* @param (message,wParam,lParam) WindowsCxgbZ[Wуp[^
* @return Ȃ
* @sa
* @detail IDD_ABOUNTBOX
*/
// o[W{bNXpbZ[W nh
LRESULT CALLBACK About( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch( message )
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if( LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL ) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

/**
* @fn SetupMIDIProc
* @brief MIDItݒ_CAO{bNXpbZ[W nh
* @param (hDlg) Windows Dialog̃nh
* @param (message,wParam,lParam) WindowsCxgbZ[Wуp[^
* @return Ȃ
* @sa
* @detail IDD_SETUP_MIDI
*/
LRESULT CALLBACK SetupMIDIProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
//	LRESULT status;
	BOOL stat;
	static int voice_pr[7]={1,54,49,62,75,20,25};
	static LPSTR voice_nm[87]={"sAm","{[J","y","uX","R[_[",
		"IK","M^["};
	int i;
	char *gmname[128]={
     "Grand Pianno","Brite Piano","Electric GrandPiano","Honky-tonk Piano",
	 "Electroc.Piano1","Electric .Piano2","Harpsichord","Clavi",
     "Celesta","Glockenspiel","Music Box","Vibraphone",
	 "Marimba","Xylophon","Tubular Bells","Dulcimer",
	 "Drawbar Organ","Percussive Organ","Rock Organ","Church Organ",
	 "Reed Organ","Accordion","Harmonica","Tango Accordion",
	 "Nylon Guitar","Steel Guitar","Jazz Guitar","Clean Guitar",
	 "Muted Guitar","Overdriven Guitar","Distortion Guitar","Guitar Harmonics",
	 "Acoustic Bass","Finger Bass","Pick Bass","Fretless Bass",
	 "Slap Bass 1","Slap Bass 2","Synth Bass 1","Synth Bass 2",
	 "Violin","Viola","Cello","Contrabass",
	 "Tremolo Strings","Pizzicato Strings","Orchestral Harp","Timpani",
	 "Strings 1","Strings 2","Synth Strings 1","Synth Strings 2",
	 "Choir Aahs","Voice Oohs","Synth Voice","Orchestra Hit",
	 "Trumpet","Trombone","Tuba","Muted Trumpet",
	 "French Horn","Brass Section","Synth Brass 1","Synth Brass 2",
	 "Soprano Sax","Alto Sax","Tenor Sax","Baritone Sax",
	 "Oboe","English Horn","Bassoon","Clarinet",
	 "Piccolo","Flute","Recorder","Pan Flute",
	 "Blown Bottle","Shakuhachi","Whistle","Ocarina",
	 "Square Lead","Sawtooth Lead","Calliope Lead","Chiff Lead",
	 "Charang Lead","Voice Lead","Fifths Lead","Bass Lead",
	 "New Age Pad","Warm Pad","Poly Synth Pad","Choir Pad",
	 "Bowed Pad","Metallic Pad","Halo Pad","Sweep Pad",
	 "Rain","Sound Track","Crystal","Atmosphere",
	 "Brightness","Goblins","Echoes","Sci-Fi",
	 "Sitar","Banjo","Shamisen","Koto",
	 "Kalimba","Bagpipe","Fiddle","Shanai",
	 "Trinkle Bell","Agogo","Steel Drums","Woodblock",
	 "Taiko Drum","Melodic Tom","Synth Drums","Reverse Cymbal",
	 "Fret Noise","Breath Noise","Seashore","Bird Tweet",
	 "Telephone Ring","Helicopter","Applause","Gunshot"
	};

	switch(uMsg)
	{
	case WM_INITDIALOG:
		SetDlgItemInt(hDlg,IDC_EDIT1,MIDI_device,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT2,MIDI_program,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT3,MIDI_tempo,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT4,MIDI_tone,TRUE);
		SetDlgItemInt(hDlg,IDC_EDIT5,MIDI_bank1,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT6,MIDI_bank2,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT7,MIDI_volume,FALSE);
		SetDlgItemText(hDlg,IDC_EDIT8,voice_nm[sel_program]);
		SetDlgItemInt(hDlg,IDC_EDIT9,MIDI_reverb,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT10,MIDI_chorus,FALSE);
// Get MIDI Device
		SendDlgItemMessage(hDlg,IDC_LIST1,LB_RESETCONTENT,0,0L);
		Get_MIDI_device_list(hDlg,IDC_LIST1);
		SendDlgItemMessage(hDlg,IDC_LIST1,LB_SETCURSEL,MIDI_device,0L);
// Create GM-program List
		SendDlgItemMessage(hDlg,IDC_LIST2,LB_RESETCONTENT,0,0L);
		for (i=0;i<128;i++) {
			SendDlgItemMessage(hDlg,IDC_LIST2,LB_INSERTSTRING,i,(LONG)(LPSTR)gmname[i]);
		}
		SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,MIDI_program-1,0L);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDCANCEL:
			EndDialog(hDlg,IDCANCEL);
			break;
		case IDC_BUTTON1:
			sel_program++;
			if (sel_program>=7) sel_program=0;
			MIDI_program=voice_pr[sel_program];
			SetDlgItemInt(hDlg,IDC_EDIT2,MIDI_program,FALSE);
			SetDlgItemInt(hDlg,IDC_EDIT5,MIDI_bank1,FALSE);
			SetDlgItemInt(hDlg,IDC_EDIT6,MIDI_bank2,FALSE);
			SetDlgItemText(hDlg,IDC_EDIT8,voice_nm[sel_program]);
			SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,MIDI_program-1,0L);
			break;
		case IDC_BUTTON2:
			sel_program--;
			if (sel_program<0) sel_program=6;
			MIDI_program=voice_pr[sel_program];
			SetDlgItemInt(hDlg,IDC_EDIT2,MIDI_program,FALSE);
			SetDlgItemInt(hDlg,IDC_EDIT5,MIDI_bank1,FALSE);
			SetDlgItemInt(hDlg,IDC_EDIT6,MIDI_bank2,FALSE);
			SetDlgItemText(hDlg,IDC_EDIT8,voice_nm[sel_program]);
			SendDlgItemMessage(hDlg,IDC_LIST2,LB_SETCURSEL,MIDI_program-1,0L);
			break;
		case IDC_BUTTON3:
			MIDI_tempo -=10;
			if (MIDI_tempo<10) MIDI_tempo=100;
			SetDlgItemInt(hDlg,IDC_EDIT3,MIDI_tempo,FALSE);
			break;
		case IDC_BUTTON4:
			MIDI_tempo +=10;
			if (MIDI_tempo>1000) MIDI_tempo=100;
			SetDlgItemInt(hDlg,IDC_EDIT3,MIDI_tempo,FALSE);
			break;
		case IDC_BUTTON5:
			MIDI_tone +=6;
			if (MIDI_tone>=48) MIDI_tone=0;
			SetDlgItemInt(hDlg,IDC_EDIT4,MIDI_tone,TRUE);
			break;
		case IDC_BUTTON6:
			MIDI_tone -=6;
			if (MIDI_tone< -48) MIDI_tone=0;
			SetDlgItemInt(hDlg,IDC_EDIT4,MIDI_tone,TRUE);
			break;
		case IDC_BUTTON7:
			MIDI_device=SendDlgItemMessage(hDlg,IDC_LIST1,LB_GETCURSEL,0,0L);
			SetDlgItemInt(hDlg,IDC_EDIT1,MIDI_device,FALSE);
			break;
		case IDC_BUTTON8:
			GM_systemON_Exclusive_Message();
			break;
		case IDC_BUTTON9:
			MIDI_program=SendDlgItemMessage(hDlg,IDC_LIST2,LB_GETCURSEL,0,0L);
			MIDI_program++;
			SetDlgItemInt(hDlg,IDC_EDIT2,MIDI_program,FALSE);
			break;
		case IDC_BUTTON13:
			MIDI_tempo=100;
			SetDlgItemInt(hDlg,IDC_EDIT3,MIDI_tempo,FALSE);
			MIDI_tone=0;
			SetDlgItemInt(hDlg,IDC_EDIT4,MIDI_tone,TRUE);
			break;
		case IDOK:
			MIDI_device=GetDlgItemInt(hDlg,IDC_EDIT1,&stat,FALSE);
			MIDI_program=GetDlgItemInt(hDlg,IDC_EDIT2,&stat,FALSE);
			MIDI_tempo=GetDlgItemInt(hDlg,IDC_EDIT3,&stat,FALSE);
			MIDI_tone=GetDlgItemInt(hDlg,IDC_EDIT4,&stat,TRUE);
			MIDI_bank1=GetDlgItemInt(hDlg,IDC_EDIT5,&stat,FALSE);
			MIDI_bank2=GetDlgItemInt(hDlg,IDC_EDIT6,&stat,FALSE);
			MIDI_volume=GetDlgItemInt(hDlg,IDC_EDIT7,&stat,FALSE);
			MIDI_reverb=GetDlgItemInt(hDlg,IDC_EDIT9,&stat,FALSE);
			MIDI_chorus=GetDlgItemInt(hDlg,IDC_EDIT10,&stat,FALSE);
			EndDialog(hDlg,IDOK);
			break;
		}
		break;
		default:
			return(FALSE);
	}
	return(TRUE);
}

/**
* @fn ParamMIDIconv1
* @brief MIDIϊEg͐ݒ_CAO{bNXpbZ[W nh
* @param (hDlg) Windows Dialog̃nh
* @param (message,wParam,lParam) WindowsCxgbZ[Wуp[^
* @return Ȃ
* @sa
* @detail IDD_MIDI_CONV1
*/
LRESULT CALLBACK ParamMIDIconv1(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	BOOL stat;
	switch(uMsg)
	{
	case WM_INITDIALOG:
		save_param=FALSE;
		SetDlgItemInt(hDlg,IDC_EDIT1,overtone_level,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT2,fft_size,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT3,variable_rate,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT4,slice_difflevel,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT5,slice_diffnote,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT6,max_overtone,FALSE);
		if (overtone_correct) CheckDlgButton(hDlg,IDC_CHECK1,1);
		else  CheckDlgButton(hDlg,IDC_CHECK1,0);
		if (fine_note) CheckDlgButton(hDlg,IDC_CHECK2,1);
		else  CheckDlgButton(hDlg,IDC_CHECK2,0);
		if (save_param) CheckDlgButton(hDlg,IDC_CHECK3,1);
		else  CheckDlgButton(hDlg,IDC_CHECK3,0);
		if (fundamental_correct) CheckDlgButton(hDlg,IDC_CHECK4,1);
		else  CheckDlgButton(hDlg,IDC_CHECK4,0);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDCANCEL:
			EndDialog(hDlg,IDCANCEL);
			break;
		case IDC_CHECK1:
			overtone_correct= !overtone_correct;
			if (overtone_correct) CheckDlgButton(hDlg,IDC_CHECK1,1);
			else  CheckDlgButton(hDlg,IDC_CHECK1,0);
			break;
		case IDC_CHECK2:
			fine_note= !fine_note;
			if (fine_note) {
				CheckDlgButton(hDlg,IDC_CHECK2,1);
				variable_rate=500;
			}
			else  {
				CheckDlgButton(hDlg,IDC_CHECK2,0);
				variable_rate=150;
			}
			SetDlgItemInt(hDlg,IDC_EDIT3,variable_rate,FALSE);
			break;
		case IDC_CHECK3:
			save_param= !save_param;
			if (save_param) CheckDlgButton(hDlg,IDC_CHECK3,1);
			else  CheckDlgButton(hDlg,IDC_CHECK3,0);
			break;
		case IDC_CHECK4:
			fundamental_correct= !fundamental_correct;
			if (fundamental_correct) CheckDlgButton(hDlg,IDC_CHECK4,1);
			else  CheckDlgButton(hDlg,IDC_CHECK4,0);
			break;
		case IDC_BUTTON1:
			if (fft_size==4096) fft_size=8192;
			else if (fft_size==8192) fft_size=1024;
			else if (fft_size==1024) fft_size=2048;
			else  fft_size=4096;
			SetDlgItemInt(hDlg,IDC_EDIT2,fft_size,FALSE);
			break;
		case IDOK:
			overtone_level=GetDlgItemInt(hDlg,IDC_EDIT1,&stat,FALSE);
			fft_size=GetDlgItemInt(hDlg,IDC_EDIT2,&stat,FALSE);
			variable_rate=GetDlgItemInt(hDlg,IDC_EDIT3,&stat,FALSE);
			slice_difflevel=GetDlgItemInt(hDlg,IDC_EDIT4,&stat,TRUE);
			slice_diffnote=GetDlgItemInt(hDlg,IDC_EDIT5,&stat,TRUE);
			max_overtone=GetDlgItemInt(hDlg,IDC_EDIT6,&stat,TRUE);
			if (save_param) Write_INITfile();
			EndDialog(hDlg,IDOK);
			break;
		}
		break;
		default:
			return(FALSE);
	}
	return(TRUE);
}


/**
* @fn ParamMIDIconv2
* @brief MIDIϊEMIDIf[^ϊݒ_CAO{bNXpbZ[W nh
* @param (hDlg) Windows Dialog̃nh
* @param (message,wParam,lParam) WindowsCxgbZ[Wуp[^
* @return Ȃ
* @sa
* @detail IDD_MIDI_CONV2
*/
LRESULT CALLBACK ParamMIDIconv2(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	BOOL stat;
	switch(uMsg)
	{
	case WM_INITDIALOG:
		if (sample_freq<=0) EndDialog(hDlg,IDCANCEL);
		save_param=FALSE;
		sec_connect_off=FALSE;
			if (fine_note) {
				slice_diffnote_abs=32;
				max_harmony=15;
				max_bitrate=20000;
			}
			else {
				slice_diffnote_abs=8;
				max_harmony=32;
				max_bitrate=9000;
			}
		SetDlgItemInt(hDlg,IDC_EDIT1,slice_interval,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT2,slice_diffnote_abs,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT3,minimum_level,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT4,maximum_level,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT5,key_min,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT6,key_max,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT7,slice_length,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT8,slice_level,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT9,max_harmony,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT10,time_unit,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT11,max_bitrate,FALSE);
			if (sec_connect_off) CheckDlgButton(hDlg,IDC_CHECK1,1);
			else  CheckDlgButton(hDlg,IDC_CHECK1,0);
			if (save_param) CheckDlgButton(hDlg,IDC_CHECK2,1);
			else  CheckDlgButton(hDlg,IDC_CHECK2,0);
			if (Cmajor_key) CheckDlgButton(hDlg,IDC_CHECK3,1);
			else  CheckDlgButton(hDlg,IDC_CHECK3,0);
// Setup Key Scale
		if (key_note[0]) CheckDlgButton(hDlg,IDC_CHECK4,1);
		else  CheckDlgButton(hDlg,IDC_CHECK4,0);
		if (key_note[1]) CheckDlgButton(hDlg,IDC_CHECK5,1);
		else  CheckDlgButton(hDlg,IDC_CHECK5,0);
		if (key_note[2]) CheckDlgButton(hDlg,IDC_CHECK6,1);
		else  CheckDlgButton(hDlg,IDC_CHECK6,0);
		if (key_note[3]) CheckDlgButton(hDlg,IDC_CHECK7,1);
		else  CheckDlgButton(hDlg,IDC_CHECK7,0);
		if (key_note[4]) CheckDlgButton(hDlg,IDC_CHECK8,1);
		else  CheckDlgButton(hDlg,IDC_CHECK8,0);
		if (key_note[5]) CheckDlgButton(hDlg,IDC_CHECK9,1);
		else  CheckDlgButton(hDlg,IDC_CHECK9,0);
		if (key_note[6]) CheckDlgButton(hDlg,IDC_CHECK10,1);
		else  CheckDlgButton(hDlg,IDC_CHECK10,0);
		if (key_note[7]) CheckDlgButton(hDlg,IDC_CHECK11,1);
		else  CheckDlgButton(hDlg,IDC_CHECK11,0);
		if (key_note[8]) CheckDlgButton(hDlg,IDC_CHECK12,1);
		else  CheckDlgButton(hDlg,IDC_CHECK12,0);
		if (key_note[9]) CheckDlgButton(hDlg,IDC_CHECK13,1);
		else  CheckDlgButton(hDlg,IDC_CHECK13,0);
		if (key_note[10]) CheckDlgButton(hDlg,IDC_CHECK14,1);
		else  CheckDlgButton(hDlg,IDC_CHECK14,0);
		if (key_note[11]) CheckDlgButton(hDlg,IDC_CHECK15,1);
		else  CheckDlgButton(hDlg,IDC_CHECK15,0);
		if (variable_interval) CheckDlgButton(hDlg,IDC_CHECK16,1);
		else  CheckDlgButton(hDlg,IDC_CHECK16,0);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDCANCEL:
			EndDialog(hDlg,IDCANCEL);
			break;
		case IDC_CHECK1:
			sec_connect_off= !sec_connect_off;
			if (sec_connect_off) CheckDlgButton(hDlg,IDC_CHECK1,1);
			else  CheckDlgButton(hDlg,IDC_CHECK1,0);
			break;
		case IDC_CHECK2:
			save_param= !save_param;
			if (save_param) CheckDlgButton(hDlg,IDC_CHECK2,1);
			else  CheckDlgButton(hDlg,IDC_CHECK2,0);
			break;
		case IDC_CHECK3:
			Cmajor_key= !Cmajor_key;
			if (Cmajor_key) CheckDlgButton(hDlg,IDC_CHECK3,1);
			else  CheckDlgButton(hDlg,IDC_CHECK3,0);
			break;
		case IDC_CHECK4:
			key_note[0]= !key_note[0];
			if (key_note[0]) CheckDlgButton(hDlg,IDC_CHECK4,1);
			else  CheckDlgButton(hDlg,IDC_CHECK4,0);
			break;
		case IDC_CHECK5:
			key_note[1]= !key_note[1];
			if (key_note[1]) CheckDlgButton(hDlg,IDC_CHECK5,1);
			else  CheckDlgButton(hDlg,IDC_CHECK5,0);
			break;
		case IDC_CHECK6:
			key_note[2]= !key_note[2];
			if (key_note[2]) CheckDlgButton(hDlg,IDC_CHECK6,1);
			else  CheckDlgButton(hDlg,IDC_CHECK6,0);
			break;
		case IDC_CHECK7:
			key_note[3]= !key_note[3];
			if (key_note[3]) CheckDlgButton(hDlg,IDC_CHECK7,1);
			else  CheckDlgButton(hDlg,IDC_CHECK7,0);
			break;
		case IDC_CHECK8:
			key_note[4]= !key_note[4];
			if (key_note[4]) CheckDlgButton(hDlg,IDC_CHECK8,1);
			else  CheckDlgButton(hDlg,IDC_CHECK8,0);
			break;
		case IDC_CHECK9:
			key_note[5]= !key_note[5];
			if (key_note[5]) CheckDlgButton(hDlg,IDC_CHECK9,1);
			else  CheckDlgButton(hDlg,IDC_CHECK9,0);
			break;
		case IDC_CHECK10:
			key_note[6]= !key_note[6];
			if (key_note[6]) CheckDlgButton(hDlg,IDC_CHECK10,1);
			else  CheckDlgButton(hDlg,IDC_CHECK10,0);
			break;
		case IDC_CHECK11:
			key_note[7]= !key_note[7];
			if (key_note[7]) CheckDlgButton(hDlg,IDC_CHECK11,1);
			else  CheckDlgButton(hDlg,IDC_CHECK11,0);
			break;
		case IDC_CHECK12:
			key_note[8]= !key_note[8];
			if (key_note[8]) CheckDlgButton(hDlg,IDC_CHECK12,1);
			else  CheckDlgButton(hDlg,IDC_CHECK12,0);
			break;
		case IDC_CHECK13:
			key_note[9]= !key_note[9];
			if (key_note[9]) CheckDlgButton(hDlg,IDC_CHECK13,1);
			else  CheckDlgButton(hDlg,IDC_CHECK13,0);
			break;
		case IDC_CHECK14:
			key_note[10]= !key_note[10];
			if (key_note[10]) CheckDlgButton(hDlg,IDC_CHECK14,1);
			else  CheckDlgButton(hDlg,IDC_CHECK14,0);
			break;
		case IDC_CHECK15:
			key_note[11]= !key_note[11];
			if (key_note[11]) CheckDlgButton(hDlg,IDC_CHECK15,1);
			else  CheckDlgButton(hDlg,IDC_CHECK15,0);
			break;
		case IDC_CHECK16:
			variable_interval= !variable_interval;
			if (variable_interval) CheckDlgButton(hDlg,IDC_CHECK16,1);
			else  CheckDlgButton(hDlg,IDC_CHECK16,0);
			break;
		case IDOK:
			slice_interval=GetDlgItemInt(hDlg,IDC_EDIT1,&stat,FALSE);
			slice_diffnote_abs=GetDlgItemInt(hDlg,IDC_EDIT2,&stat,FALSE);
			minimum_level=GetDlgItemInt(hDlg,IDC_EDIT3,&stat,FALSE);
			maximum_level=GetDlgItemInt(hDlg,IDC_EDIT4,&stat,FALSE);
			key_min=GetDlgItemInt(hDlg,IDC_EDIT5,&stat,FALSE);
			key_max=GetDlgItemInt(hDlg,IDC_EDIT6,&stat,FALSE);
			slice_length=GetDlgItemInt(hDlg,IDC_EDIT7,&stat,FALSE);
			slice_level=GetDlgItemInt(hDlg,IDC_EDIT8,&stat,FALSE);
			max_harmony=GetDlgItemInt(hDlg,IDC_EDIT9,&stat,FALSE);
			time_unit=GetDlgItemInt(hDlg,IDC_EDIT10,&stat,FALSE);
			max_bitrate=GetDlgItemInt(hDlg,IDC_EDIT11,&stat,FALSE);
			if (save_param) Write_INITfile();
			EndDialog(hDlg,IDOK);
			break;
		}
		break;
		default:
			return(FALSE);
	}
	return(TRUE);
}

/**
* @fn Setup_Display
* @brief MIDI\[hݒ_CAO{bNXpbZ[W nh
* @param (hDlg) Windows Dialog̃nh
* @param (message,wParam,lParam) WindowsCxgbZ[Wуp[^
* @return Ȃ
* @sa
* @detail IDD_DISPLAY
*/
LRESULT CALLBACK Setup_Display(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	BOOL stat;
	switch(uMsg)
	{
	case WM_INITDIALOG:
		SetDlgItemInt(hDlg,IDC_EDIT1,time_start_disp,TRUE);
		SetDlgItemInt(hDlg,IDC_EDIT2,time_end_disp,TRUE);
		SetDlgItemInt(hDlg,IDC_EDIT3,key_min_disp,FALSE);
		SetDlgItemInt(hDlg,IDC_EDIT4,key_max_disp,FALSE);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDCANCEL:
			EndDialog(hDlg,IDCANCEL);
			break;
		case IDC_BUTTON1:
			time_start_disp=0;
			time_end_disp= -1;
			key_min_disp=19;
			key_max_disp=112;
			EndDialog(hDlg,IDOK);
			break;
		case IDC_BUTTON2:
			time_start_disp=note_time_on*1000/time_unit;
			SetDlgItemInt(hDlg,IDC_EDIT1,time_start_disp,TRUE);
			break;
		case IDC_BUTTON3:
			time_end_disp=note_time_off*1000/time_unit;
			SetDlgItemInt(hDlg,IDC_EDIT2,time_end_disp,TRUE);
			break;
		case IDC_BUTTON4:
			key_min_disp=note_number;
			SetDlgItemInt(hDlg,IDC_EDIT3,key_min_disp,FALSE);
			break;
		case IDC_BUTTON5:
			key_max_disp=note_number;
			SetDlgItemInt(hDlg,IDC_EDIT4,key_max_disp,FALSE);
			break;
		case IDOK:
			time_start_disp=GetDlgItemInt(hDlg,IDC_EDIT1,&stat,TRUE);
			time_end_disp=GetDlgItemInt(hDlg,IDC_EDIT2,&stat,TRUE);
			key_min_disp=GetDlgItemInt(hDlg,IDC_EDIT3,&stat,FALSE);
			key_max_disp=GetDlgItemInt(hDlg,IDC_EDIT4,&stat,FALSE);
			EndDialog(hDlg,IDOK);
			break;
		}
		break;
		default:
			return(FALSE);
	}
	return(TRUE);
}
