/**
* @file MIDdraw.cpp
* @brief MIDIf[^̃OtBbN\
* @author T.Modegi
* @date  2023.8.5
*/
#include "StdAfx.h"
#include <stdio.h>
#include <commctrl.h>
#include "common.h"
#include "commparam.h"
#include "MIDfile.h"
#include "commdata.h"
#include "MIDcnv_s4_mid.h"
#include "MIDedit.h"

extern HWND hStatusWnd;
HPEN penf,penh,penm;
HBRUSH brushf[12],brushw,brushg;
RECT winrt,statrt;
int sizex,sizey;
int shiftx=0;
int shifty=0;
int scale_x=100;
int scale_y=100;
int offset_x=0;
int offset_y=0;
POINT point[5];
int note_val[128];
int note_pos[128];
int note_chan[16];
int num_prev,num_prev2;
char buff_prev[128],buff_prev2[128];
int max_line,cur_line,prev_line,prev_line2;
BOOL select_flg=FALSE;

int select_midinote_bck= -1;

/**
* @fn Set_Draw_Window
* @brief `EBhE̐ݒ
* @param (sx,sy) EBhȄcXP[
* @param (ox,oy) EBhEzũItZbg
* @return Ȃ
* @sa 
* @detail
*/
void Set_Draw_Window(int sx,int sy,int ox,int oy)
{
	scale_x=sx;
	scale_y=sy;
	offset_x=ox;
	offset_y=oy;
}

/**
* @fn Set_Draw_Window
* @brief `EBhE̐ݒ
* @param (hwnd)  `ΏۃEBhẼnh
* @return Ȃ
* @sa 
* @detail
*/
void Calc_Draw_Window(HWND hwnd)
{
	GetClientRect( hwnd, &winrt );
	winrt.bottom -=25;
	sizex=winrt.right-winrt.left+1;
	sizey=winrt.bottom-winrt.top+1;

	if (scale_x!=100 || scale_y!=100 || offset_x!=0 || offset_y!=0) {
		shiftx=sizex*offset_x/100;
		shifty=sizey*offset_y/100;
		sizex=sizex*scale_x/100;
		sizey=sizey*scale_y/100;
		winrt.left=shiftx;
		winrt.right=shiftx+sizex-1;
		winrt.top=shifty;
		winrt.bottom=shifty+sizey-1;
	}
	else {
		shiftx=shifty=0;
	}

	sizex -=30;
	shiftx=30;
}

/**
* @fn Draw_Keyboard
* @brief L[{[h`悷
* @param (hdc)  `ΏۃReLXg̃nh
* @return Ȃ
* @sa 
* @detail
*/
void Draw_Keyboard(HDC hdc)
{
	int i,k;
	int y1,y2,yo;

	RECT rt;
	HPEN penb;
	penb=CreatePen(PS_SOLID,1,RGB(0,0,0));
	
	rt.left=0;
	rt.right=30;
	rt.top=shifty;
	rt.bottom=shifty+sizey;
	FillRect(hdc,&rt,(HBRUSH)GetStockObject(WHITE_BRUSH));

	SelectObject(hdc,penb);	
	for (i=key_min_disp;i<=key_max_disp;i++) {
		k=i%12;
		if (k==2 || k==7 || k==9) { 
			y1=(key_max_disp-i-1)*sizey/(key_max_disp-key_min_disp+1)+shifty;
			y2=(key_max_disp-i+1)*sizey/(key_max_disp-key_min_disp+1)+shifty;
		}
		else if (k==0 || k==5) { 
			y1=(key_max_disp-i-1)*sizey/(key_max_disp-key_min_disp+1)+shifty;
			y2=(key_max_disp-i+1)*sizey/(key_max_disp-key_min_disp+1)+shifty;
			yo=(key_max_disp-i)*sizey/(key_max_disp-key_min_disp+1)+shifty;
			y2=(y2+yo)/2;
		}
		else if (k==4 || k==11) { 
			y1=(key_max_disp-i-1)*sizey/(key_max_disp-key_min_disp+1)+shifty;
			yo=(key_max_disp-i)*sizey/(key_max_disp-key_min_disp+1)+shifty;
			y1=(y1+yo)/2;
			y2=(key_max_disp-i+1)*sizey/(key_max_disp-key_min_disp+1)+shifty;
		}
		Rectangle(hdc,0,y1,30,y2);
	}
	for (i=key_min_disp;i<=key_max_disp;i++) {
		k=i%12;
		if (k==1 || k==3 || k==6 || k==8 || k==10) {
			rt.left=0;
			rt.right=15;
			yo=(key_max_disp-i)*sizey/(key_max_disp-key_min_disp+1)+shifty;
			y1=(key_max_disp-i-1)*sizey/(key_max_disp-key_min_disp+1)+shifty;
			y2=(key_max_disp-i+1)*sizey/(key_max_disp-key_min_disp+1)+shifty;
			rt.top=(y1+yo)/2;
			rt.bottom=(y2+yo)/2;
			FillRect(hdc,&rt,(HBRUSH)GetStockObject(BLACK_BRUSH));
		}
	}

	DeleteObject(penb);
}

/**
* @fn Draw_Frame
* @brief MIDIf[^\psAm[ʂ`悷
* @param (hdc)  `ΏۃReLXg̃nh
* @return Ȃ
* @sa Draw_Keyboard
* @detail
*/
void Draw_Frame(HDC hdc)
{
	int i,y,k,j;
	int x,dx,t;
	char mess[10];
	HPEN pen1,pen2,pen3;

	pen1=CreatePen(PS_SOLID,2,RGB(0,0,0));
	pen2=CreatePen(PS_SOLID,1,RGB(80,80,80));
	pen3=CreatePen(PS_SOLID,1,RGB(150,150,150));
// Horizontal Line
	for (i=key_min_disp;i<=key_max_disp;i++) {
		k=i%12;
		if (k==0 || k==2 || k==4 || k==5 || k==7 || k==9 || k==11) { 
		if (i==69)
			SelectObject(hdc,pen1);
		else if (k==0)
			SelectObject(hdc,pen2);
		else 
			SelectObject(hdc,pen3);
		y=(key_max_disp-i)*sizey/(key_max_disp-key_min_disp+1)+shifty;
		MoveToEx(hdc,shiftx,y,NULL);
		LineTo(hdc,sizex-1+shiftx,y);
		}
	}

// Vertical Line
	x=time_unit*sizex/abs_time+shiftx;
	dx=time_unit*sizex/abs_time;
	t=1;
	while (x<sizex) {
		if (t%10==0)
			SelectObject(hdc,pen1);
		else if (t%5==0)
			SelectObject(hdc,pen2);
		else 
			SelectObject(hdc,pen3);
		MoveToEx(hdc,x,shifty,NULL);
		LineTo(hdc,x,sizey-1+shifty);
		x +=dx;
		t++;
	}

// Text
	Draw_Keyboard(hdc);

// Text
	SetTextColor(hdc,RGB(0,0,80));
	SetBkColor(hdc,RGB(255,255,255));
	x=time_unit*sizex/abs_time+shiftx;
	dx=time_unit*sizex/abs_time;
	t=1;
	while (x<sizex) {
		if (t==1)  sprintf(mess,"%d [sec]",t);
		else sprintf(mess,"%d",t);
		for (j=0;j<10;j++) if (mess[j]=='\0') break;
		TextOut(hdc,x,sizey-1+shifty-15,mess,j);
		x +=dx;
		t++;
	}

	DeleteObject(pen1);
	DeleteObject(pen2);
	DeleteObject(pen3);
}

/**
* @fn Set_Tone_Color
* @brief MIDIf[^\p̐Fݒ
* @param () Ȃ
* @return Ȃ
* @sa 
* @detail 12K̐F\
*/
void Set_Tone_Color()
{
	int i;
//	static int colr[12]={255,213,171,129, 87, 45,  0,  0,  0,  0,  0,  0};
//	static int colg[12]={  0, 23, 46, 69, 92,115,138,161,184,207,230,255};
//	static int colb[12]={  0,  0,  0,  0,  0,  0, 45, 87,129,171,213,255};
	static int colr2[12]={255,255,255,128,  0,  0,  0,  0,  0,128,255,255};
	static int colg2[12]={  0,128,255,255,255,255,255,128,  0,  0,  0,  0};
	static int colb2[12]={  0,  0,  0,  0,  0,128,255,255,255,255,255,128};

	for (i=0;i<12;i++)
			brushf[i]=CreateSolidBrush(RGB(colr2[i],colg2[i],colb2[i]));
}

/**
* @fn Open_Draw
* @brief MIDIf[^\psAm[ʂ̕`揉ݒiCj
* @param (hwnd)  `ΏۃEBhẼnh
* @param (hdc)  `ΏۃReLXg̃nh
* @return Ȃ
* @sa Calc_Draw_Window,Set_Tone_Color,Draw_Frame
* @detail
*/
void Open_Draw(HWND hwnd,HDC hdc)
{
	int i;
	Calc_Draw_Window(hwnd);
	FillRect(hdc,&winrt,(HBRUSH)GetStockObject(WHITE_BRUSH));
	penf=CreatePen(PS_SOLID,1,RGB(0,0,0));
	penh=CreatePen(PS_SOLID,1,RGB(150,150,150));
	penm=CreatePen(PS_SOLID,5,RGB(0,128,0));
//	brushf=(HBRUSH *)malloc(12*sizeof(HBRUSH));
	brushw=CreateSolidBrush(RGB(255,255,255));
	brushg=CreateSolidBrush(RGB(150,150,150));
	for (i=0;i<128;i++) {
		note_val[i]=note_pos[i]=0;
	}
	for (i=0;i<16;i++) note_chan[i]= -1;
	Set_Tone_Color();
	Draw_Frame(hdc);
}

/**
* @fn Close_Draw
* @brief MIDIf[^\psAm[ʂ̕`I
* @param () Ȃ
* @return Ȃ
* @sa 
* @detail
*/
void Close_Draw()
{
	int i;
	DeleteObject(penf);
	DeleteObject(penh);
	DeleteObject(penm);
	for (i=0;i<12;i++)  DeleteObject(brushf[i]);
//	free(brushf);
	DeleteObject(brushw);
	DeleteObject(brushg);
}

/**
* @fn Draw_Note_2
* @brief MIDIf[^\psAm[ʂɉ\i``j
* @param (hdc)  `ΏۃReLXg̃nh
* @param (t) `悷鉹̎
* @param (tt) `悷MIDIf[^̑St
* @param (data) `悷鉹MIDIf[^
* @param (key) L[{[hɃ}[N邩ۂiTRUE/FALSE)
* @return Ȃ
* @sa 
* @detail
*/
void Draw_Note_2(HDC hdc,int t,int tt,MIDIMSG data,BOOL key)
{
	int note,vel,sw,ch;
	int x,y,xo,to;
	int k,y1,y2,dx;
	int yy1,yy2;
	int col;
	int bend;
	double dn;
	RECT rt;
	ch=data.com & 0xf;
	vel=data.vel;
	note=data.note;
	col=note%12;
	sw=data.com;
	if ((sw<0x80 || sw>0x9f) && (sw<0xe0 || sw>0xef || disp_pitchbend==FALSE))  return;
	x=t*sizex/tt+shiftx;
	if (sw>=0x80 && sw<=0x9f) {
	y=(key_max_disp-note)*sizey/(key_max_disp-key_min_disp+1)+shifty;
		y1=(key_max_disp-note-1)*sizey/(key_max_disp-key_min_disp+1)+shifty;
		y2=(key_max_disp-note+1)*sizey/(key_max_disp-key_min_disp+1)+shifty;
	}

	if (key) {
		rt.top=(y1+y*2)/3;
		rt.bottom=(y2+y*2)/3;
		k=note%12;
		if (k==1 || k==3 || k==6 || k==8 || k==10) { rt.left=0; rt.right=15;}
		else { rt.left=17; rt.right=28;}
	}

	if (sw>=0x90 && sw<=0x9f) {
		note_val[note]=vel;
		note_pos[note]=t;
		note_chan[ch]=note;
		if (key) {
			dx=24*vel/127;
			if (dx<0) dx=1;
			if (dx>11) dx=11;
			rt.right=dx+rt.left;
			FillRect(hdc,&rt,brushf[0]);
		}
	}
	else if (sw>=0x80 && sw<=0x8f) {
		to=note_pos[note];
		vel=note_val[note];
		xo=to*sizex/tt+shiftx;
		yy1=(y1-y)*vel/64+y;
		if (yy1<y1)  yy1=y1;
		yy2=(y2-y)*vel/64+y;
		if (yy2>y2)  yy2=y2;
		if (select_flg) 
		SelectObject(hdc,penm);
		else
		SelectObject(hdc,penf);
		SelectObject(hdc,brushf[col]);
		Rectangle(hdc,xo,yy1,x,yy2);
		note_val[note]=note_pos[note]=0;
		note_chan[ch]= -1;

		if (key) {
		if (rt.left==0)
			FillRect(hdc,&rt,(HBRUSH)GetStockObject(BLACK_BRUSH));
		else
			FillRect(hdc,&rt,(HBRUSH)GetStockObject(WHITE_BRUSH));
		}
	}
	else if (sw>=0xe0 && sw<=0xef) {
		bend=note+vel*128;
		note=note_chan[ch];
		if (note>=0 && note<=127) {
		col=note%12;
		dn=(double)note+(double)(bend-8192)/4096.0;
		to=note_pos[note];
		vel=note_val[note];
		xo=to*sizex/tt+shiftx;
		y=(int)(((double)key_max_disp-dn)*(double)sizey/(double)(key_max_disp-key_min_disp+1))+shifty;
		y1=(int)(((double)key_max_disp-dn-1.0)*(double)sizey/(double)(key_max_disp-key_min_disp+1))+shifty;
		y2=(int)(((double)key_max_disp-dn+1.0)*(double)sizey/(double)(key_max_disp-key_min_disp+1))+shifty;

		yy1=(y1-y)*vel/64+y;
		if (yy1<y1)  yy1=y1;
		yy2=(y2-y)*vel/64+y;
		if (yy2>y2)  yy2=y2;
		if (select_flg) 
		SelectObject(hdc,penm);
		else
		SelectObject(hdc,penf);
		SelectObject(hdc,brushf[col]);
		Rectangle(hdc,xo,yy1,x,yy2);
		note_pos[note]=t;
		}
	}
}

/**
* @fn Draw_Note
* @brief  MIDIf[^\psAm[ʂɉ\iOp``j
* @param (hdc)  `ΏۃReLXg̃nh
* @param (t) `悷鉹̎
* @param (tt) `悷MIDIf[^̑St
* @param (data) `悷鉹MIDIf[^
* @param (key) L[{[hɃ}[N邩ۂiTRUE/FALSE)
* @return Ȃ
* @sa 
* @detail
*/
void Draw_Note(HDC hdc,int t,int tt,MIDIMSG data,BOOL key)
{
	int note,vel,sw,ch;
	int x,y,xo,to;
	int k,y1,y2,dx;
	int col;
	int bend;
	double dn;
	RECT rt;
	ch=data.com & 0xf;
	if (display_rect_event)  {Draw_Note_2(hdc,t,tt,data,key); return;}
	vel=data.vel;
	note=data.note;
	col=note%12;
	sw=data.com;
	if ((sw<0x80 || sw>0x9f) && (sw<0xe0 || sw>0xef || disp_pitchbend==FALSE))  return;
	x=t*sizex/tt+shiftx;
	if (sw>=0x80 && sw<=0x9f) 
	y=(key_max_disp-note)*sizey/(key_max_disp-key_min_disp+1)+shifty;

	if (key) {
		y1=(key_max_disp-note-1)*sizey/(key_max_disp-key_min_disp+1)+shifty;
		y2=(key_max_disp-note+1)*sizey/(key_max_disp-key_min_disp+1)+shifty;
		rt.top=(y1+y*2)/3;
		rt.bottom=(y2+y*2)/3;
		k=note%12;
		if (k==1 || k==3 || k==6 || k==8 || k==10) { rt.left=0; rt.right=15;}
		else { rt.left=17; rt.right=28;}
	}

	if (sw>=0x90 && sw<=0x9f) {
		note_val[note]=vel;
		note_pos[note]=t;
		note_chan[ch]=note;
		if (key) {
			dx=24*vel/127;
			if (dx<0) dx=1;
			if (dx>11) dx=11;
			rt.right=dx+rt.left;
			FillRect(hdc,&rt,brushf[0]);
		}
	}
	else if (sw>=0x80 && sw<=0x8f) {
		to=note_pos[note];
		vel=note_val[note];
		xo=to*sizex/tt+shiftx;

		SelectObject(hdc,brushf[col]);
		point[0].x=xo;
		point[0].y=y;
		point[1].x=x;
		point[1].y=y;
//		point[2].x=(x+xo)/2;
		point[2].x=xo;
		point[2].y=y+vel/2;
		Polygon(hdc,point,3);
		point[3].x=xo;
		point[3].y=y;
		if (select_flg) 
		SelectObject(hdc,penm);
		else
		SelectObject(hdc,penf);
		Polyline(hdc,point,4);
		note_val[note]=note_pos[note]=0;
		note_chan[ch]= -1;

		if (key) {
		if (rt.left==0)
			FillRect(hdc,&rt,(HBRUSH)GetStockObject(BLACK_BRUSH));
		else
			FillRect(hdc,&rt,(HBRUSH)GetStockObject(WHITE_BRUSH));
		}
	}
	else if (sw>=0xe0 && sw<=0xef) {
		bend=note+vel*128;
		note=note_chan[ch];
		if (note>=0 && note<=127) {
		col=note%12;
		dn=(double)note+(double)(bend-8192)/4096.0;
		to=note_pos[note];
		vel=note_val[note];
		xo=to*sizex/tt+shiftx;
		y=(int)(((double)key_max_disp-dn)*(double)sizey/(double)(key_max_disp-key_min_disp+1))+shifty;

		SelectObject(hdc,brushf[col]);
		point[0].x=xo;
		point[0].y=y;
		point[1].x=x;
		point[1].y=y;
//		point[2].x=(x+xo)/2;
		point[2].x=xo;
		point[2].y=y+vel/2;
		Polygon(hdc,point,3);
		point[3].x=xo;
		point[3].y=y;
		if (select_flg) 
		SelectObject(hdc,penm);
		else
		SelectObject(hdc,penf);
		Polyline(hdc,point,4);
		note_pos[note]=t;
		}
	}
}

/**
* @fn Draw_Note_bck_2
* @brief  MIDIf[^\psAm[ʂɉ\iwi֊s\A``j
* @param (hdc)  `ΏۃReLXg̃nh
* @param (t) `悷鉹̎
* @param (tt) `悷MIDIf[^̑St
* @param (data) `悷鉹MIDIf[^
* @return Ȃ
* @sa 
* @detail
*/
void Draw_Note_bck_2(HDC hdc,int t,int tt,MIDIMSG data)
{
	int note,vel,sw,ch;
	int x,y,xo,to;
	int y1,y2,yy1,yy2;
	int col;
	ch=data.com & 0xf;
	vel=data.vel;
	note=data.note;
	col=note%12;
	sw=data.com;
	if (sw<0x80 || sw>0x9f)  return;
	x=t*sizex/tt+shiftx;
	y=(key_max_disp-note)*sizey/(key_max_disp-key_min_disp+1)+shifty;
		y1=(key_max_disp-note-1)*sizey/(key_max_disp-key_min_disp+1)+shifty;
		y2=(key_max_disp-note+1)*sizey/(key_max_disp-key_min_disp+1)+shifty;

	if (sw>=0x90 && sw<=0x9f) {
		note_val[note]=vel;
		note_pos[note]=t;
		note_chan[ch]=note;
	}
	else if (sw>=0x80 && sw<=0x8f) {
		to=note_pos[note];
		vel=note_val[note];
		xo=to*sizex/tt+shiftx;
		yy1=(y1-y)*vel/64+y;
		if (yy1<y1) yy1=y1;
		yy2=(y2-y)*vel/64+y;
		if (yy2>y2) yy2=y2;
		if (select_flg) 
		SelectObject(hdc,penm);
		else
		SelectObject(hdc,penh);
		Rectangle(hdc,xo,yy1,x,yy2);
		note_val[note]=note_pos[note]=0;
		note_chan[ch]= -1;
	}
}

/**
* @fn Draw_Note_bck
* @brief  MIDIf[^\psAm[ʂɉ\iwi֊s\AOp``j
* @param (hdc)  `ΏۃReLXg̃nh
* @param (t) `悷鉹̎
* @param (tt) `悷MIDIf[^̑St
* @param (data) `悷鉹MIDIf[^
* @return Ȃ
* @sa 
* @detail
*/
void Draw_Note_bck(HDC hdc,int t,int tt,MIDIMSG data)
{
	int note,vel,sw,ch;
	int x,y,xo,to;
	int col;
	ch=data.com & 0xf;
	if (display_rect_event)  {Draw_Note_bck_2(hdc,t,tt,data); return;}
	vel=data.vel;
	note=data.note;
	col=note%12;
	sw=data.com;
	if (sw<0x80 || sw>0x9f)  return;
	x=t*sizex/tt+shiftx;
	y=(key_max_disp-note)*sizey/(key_max_disp-key_min_disp+1)+shifty;

	if (sw>=0x90 && sw<=0x9f) {
		note_val[note]=vel;
		note_pos[note]=t;
		note_chan[ch]=note;
	}
	else if (sw>=0x80 && sw<=0x8f) {
		to=note_pos[note+ch];
		vel=note_val[note+ch];
		xo=to*sizex/tt+shiftx;
		point[0].x=xo;
		point[0].y=y;
		point[1].x=x;
		point[1].y=y;
//		point[2].x=(x+xo)/2;
		point[2].x=xo;
		point[2].y=y+vel/2;
		point[3].x=xo;
		point[3].y=y;
		if (select_flg) 
		SelectObject(hdc,penm);
		else
		SelectObject(hdc,penh);
		Polyline(hdc,point,4);
		note_val[note]=note_pos[note]=0;
		note_chan[ch]= -1;
	}
}

/**
* @fn Draw_Mess
* @brief  MIDIf[^̎dlXe[^Xo[ɃeLXg\
* @param ()  Ȃ
* @return Ȃ
* @sa 
* @detail
*/
void Draw_Mess()
{
	int i;
	int br;
	int n,p;
	char mess[256];
	char fn[256];
	int eng;
	n=255;
	for (i=0;i<256;i++) {
		fn[i]=fname_bck[i];
		if (fname_bck[i]=='\0') { n=i; break; }
	}
	p= -1;
	for (i=n;i>=0;i--) if (fn[i]=='.') {p=i; break;}
	if (p>=0) {
		fn[p+1]='T';
		fn[p+2]='X';
		fn[p+3]='T';
	}

	for (i=0;i<256;i++) mess[i]='\0';
	br=count_bitrate();
	cur_bitrate=br;
	eng=calc_total_midi_energy();
	sprintf(mess,"MIDIt@C:%s Cxg:%d t:%d `l:%d a:%d ʔ䗦:%d [bps]:%d\n",
		fn,song_len,total_time,max_channel,cur_harmony,eng,br);
	SendMessage(hStatusWnd,SB_SETTEXT,0,(LPARAM)mess);
}

/**
* @fn Redisplay_MIDI
* @brief  sAm[ʂɑSĂMIDIf[^ŕ\iCj
* @param (hwnd)  `ΏۃEBhẼnh
* @param (hdc)  `ΏۃReLXg̃nh
* @return Ȃ
* @sa Open_Draw,Draw_Note,Close_Draw,Draw_Mess
* @detail
*/
void Redisplay_MIDI(HWND hwnd,HDC hdc)
{
	int i,te;
	DWORD t1,t2;
	if (song_len<=0) return;
	abs_time=MidiMsg[song_len-1].ms;
	t1=t2=0;
	if (time_end_disp>0 || time_start_disp>0) {
		if (time_end_disp== -1)  te=MidiMsg[song_len-1].ms*1000/time_unit;
		else  te=time_end_disp;
		if (te>time_start_disp) {
		abs_time=(te-time_start_disp)*time_unit/1000;
		t1=(DWORD)(time_start_disp*time_unit/1000);
		t2=(DWORD)(te*time_unit/1000);
		}
	}
	total_time=MidiMsg[song_len-1].ms*1000/time_unit;
	Open_Draw(hwnd,hdc);
	for (i=0;i<(int)song_len;i++)
	{
		if (i==select_midinote || i==select_midinote2) select_flg=TRUE;
		else select_flg=FALSE;
		if (MidiMsg[i].ms>=t1 && (time_end_disp== -1 || MidiMsg[i].ms<=t2)) 
		Draw_Note(hdc,MidiMsg[i].ms-t1,abs_time,MidiMsg[i],FALSE);
	}
	Close_Draw();
	Draw_Mess();
}

/**
* @fn Select_MIDI
* @brief  ʏŎwꂽQWɑΉMIDIf[^擾
* @param (x,y)  ʏ̂QW
* @return Ȃ
* @sa
* @detail IꂽMIDIf[^dĺAȉO[oϐɐݒ肳
select_midinoteim[gĨAhXj,select_midinote2im[gIt̃AhXj
note_time_onim[gIj,note_time_offim[gItj,
note_velocityixVeBj,note_numberim[gio[j
*/
void Select_MIDI(int x,int y)
{
	int i,ii,t,t1,n,nb,vb,t2;
	int nb2,ii2,vb2,nb3,ii3,vb3;
	int ie,ie2,ie3,nn,nn2,nn3;
	int note,vel,sw;

	if (song_len<=0) return;
	abs_time=MidiMsg[song_len-1].ms;

	t1=0;
	if (time_end_disp== -1)  t2=MidiMsg[song_len-1].ms*1000/time_unit;
	else  t2=time_end_disp;
	if (t2>time_start_disp) {
		abs_time=(t2-time_start_disp)*time_unit/1000;
		t1=(DWORD)(time_start_disp*time_unit/1000);
	}
	t=(x-shiftx)*abs_time/sizex+t1;
	n=key_max_disp-(y-shifty)*(key_max_disp-key_min_disp+1)/sizey-1;

	nb=ii=vb=nb2=ii2=vb2=nb3=ii3=vb3=ie=ie2=ie3=nn=nn2=nn3= -1;
	for (i=0;i<(int)song_len;i++)
	{
		sw=MidiMsg[i].com;
		note=MidiMsg[i].note;
		vel=MidiMsg[i].vel;
		if (nb<0 && sw>=0x90 && sw<=0x9f) {
			if (t>=(int)MidiMsg[i].ms && n>=note-1 && n<=note+1) {
				ii=i;
				nb=note;
				vb=vel;
			}
		}
		else if (nb2<0 && sw>=0x90 && sw<=0x9f) {
			if (t>=(int)MidiMsg[i].ms && n>=note-1 && n<=note+1) {
				ii2=i;
				nb2=note;
				vb2=vel;
			}
		}
		else if (nb3<0 && sw>=0x90 && sw<=0x9f) {
			if (t>=(int)MidiMsg[i].ms && n>=note-1 && n<=note+1) {
				ii3=i;
				nb3=note;
				vb3=vel;
			}
		}
		else if (nb>=0 && sw>=0x80 && sw<=0x8f && note==nb) {
			if (t<(int)MidiMsg[i].ms) {
				ie=i;
				nn=nb;
				if (nn2>=0 &&nn3>=0) break;
			}
			nb= -1;
		}
		else if (nb2>=0 && sw>=0x80 && sw<=0x8f && note==nb2) {
			if (t<(int)MidiMsg[i].ms) {
				ie2=i;
				nn2=nb2;
				if (nn>=0 &&nn3>=0) break;
			}
			nb2= -1;
		}
		else if (nb3>=0 && sw>=0x80 && sw<=0x8f && note==nb3) {
			if (t<(int)MidiMsg[i].ms) {
				ie3=i;
				nn3=nb3;
				if (nn>=0 &&nn2>=0) break;
			}
			nb3= -1;
		}
		else if (t<(int)MidiMsg[i].ms && sw>=0x90 && sw<=0x9f) break;
	}
	if (nn>=0 && ii!=select_midinote && ii!=select_midinote_bck) {
		select_midinote_bck=select_midinote;
		select_midinote=ii;
		select_midinote2=ie;
		note_time_on=MidiMsg[select_midinote].ms;
		note_time_off=MidiMsg[select_midinote2].ms;
		note_velocity=vb;
		note_number=nn;
	}
	else if (nn2>=0 && ii2!=select_midinote && ii2!=select_midinote_bck) {
		select_midinote_bck=select_midinote;
		select_midinote=ii2;
		select_midinote2=ie2;
		note_time_on=MidiMsg[select_midinote].ms;
		note_time_off=MidiMsg[select_midinote2].ms;
		note_velocity=vb2;
		note_number=nn2;
	}
	else if (nn3>=0 && ii3!=select_midinote && ii3!=select_midinote_bck) {
		select_midinote_bck=select_midinote;
		select_midinote=ii3;
		select_midinote2=ie3;
		note_time_on=MidiMsg[select_midinote].ms;
		note_time_off=MidiMsg[select_midinote2].ms;
		note_velocity=vb3;
		note_number=nn3;
	}
	else if (nn>=0 && ii!=select_midinote) {
		select_midinote_bck=select_midinote;
		select_midinote=ii;
		select_midinote2=ie;
		note_time_on=MidiMsg[select_midinote].ms;
		note_time_off=MidiMsg[select_midinote2].ms;
		note_velocity=vb;
		note_number=nn;
	}
	else if (nn2>=0 && ii2!=select_midinote) {
		select_midinote_bck=select_midinote;
		select_midinote=ii2;
		select_midinote2=ie2;
		note_time_on=MidiMsg[select_midinote].ms;
		note_time_off=MidiMsg[select_midinote2].ms;
		note_velocity=vb2;
		note_number=nn2;
	}
	else if (nn3>=0 && ii3!=select_midinote) {
		select_midinote_bck=select_midinote;
		select_midinote=ii3;
		select_midinote2=ie3;
		note_time_on=MidiMsg[select_midinote].ms;
		note_time_off=MidiMsg[select_midinote2].ms;
		note_velocity=vb3;
		note_number=nn3;
	}
	else if (nn>=0) {
		select_midinote_bck=select_midinote;
		select_midinote=ii;
		select_midinote2=ie;
		note_time_on=MidiMsg[select_midinote].ms;
		note_time_off=MidiMsg[select_midinote2].ms;
		note_velocity=vb;
		note_number=nn;
	}
	else if (nn2>=0) {
		select_midinote_bck=select_midinote;
		select_midinote=ii2;
		select_midinote2=ie2;
		note_time_on=MidiMsg[select_midinote].ms;
		note_time_off=MidiMsg[select_midinote2].ms;
		note_velocity=vb2;
		note_number=nn2;
	}
	else if (nn3>=0) {
		select_midinote_bck=select_midinote;
		select_midinote=ii3;
		select_midinote2=ie3;
		note_time_on=MidiMsg[select_midinote].ms;
		note_time_off=MidiMsg[select_midinote2].ms;
		note_velocity=vb3;
		note_number=nn3;
	}

}
