/**
* @file WAVdraw.cpp
* @brief WAVf[^̃OtBbN\
* @author T.Modegi
* @date  2023.8.5
*/
#include "StdAfx.h"
#include <stdio.h>
#include <commctrl.h>
#include "common.h"
#include "commparam.h"
#include "commdata.h"
#include "MIDdraw.h"

extern HWND hStatusWnd;
extern RECT winrt;
extern int sizex,sizey;
extern int shiftx,shifty;

/**
* @fn Draw_MessW
* @brief  WAVEf[^̎dlXe[^Xo[ɃeLXg\
* @param ()  Ȃ
* @return Ȃ
* @sa 
* @detail
*/
void Draw_MessW()
{
	int i;
	int n,p;
	char mess[256];
	char fn[256];
	n=255;
	for (i=0;i<256;i++) {
		fn[i]=fname_wav_bck[i];
		if (fname_wav_bck[i]=='\0') { n=i; break; }
	}
	p= -1;
	for (i=n;i>=0;i--) if (fn[i]=='.') {p=i; break;}
	if (p>=0) {
		fn[p+1]='W';
		fn[p+2]='A';
		fn[p+3]='V';
	}

	for (i=0;i<256;i++) mess[i]='\0';
		sprintf(mess,"WAVEt@C:%s TvOg:%d[Hz] ʎqrbg:%d[bits] `l:%d t:%d[msec]\n",
		fn,sample_freq,bit_per_sample,wav_channel,total_time);
	SendMessage(hStatusWnd,SB_SETTEXT,0,(LPARAM)mess);
}

/**
* @fn Draw_Wave
* @brief  WAVEf[^ʂɔg`ŕ\
* @param (hwnd)  `ΏۃEBhẼnh
* @param (hdc)  `ΏۃReLXg̃nh
* @param (num_sample)  WAVEf[^̑Tv
* @param (wavbuf)  WAVEf[^̔z
* @param (chan)  WAVEf[^\`l(0/1)
* @return Ȃ
* @sa Open_Draw,Draw_Note,Close_Draw,Draw_Mess
* @detail
*/
void Draw_Wave(HWND hwnd,HDC hdc,int num_sample,short wavbuf[],int chan)
{
	int x,y,i;
	int sy2;
	int xp,yp,yp1,yp2;
	HPEN pen1,pen2;
	Calc_Draw_Window(hwnd);
	FillRect(hdc,&winrt,(HBRUSH)GetStockObject(WHITE_BRUSH));

	sy2=sizey/2;
	pen1=CreatePen(PS_SOLID,2,RGB(50,50,50));
	pen2=CreatePen(PS_SOLID,1,RGB(0,100,0));
	SelectObject(hdc,pen1);
	MoveToEx(hdc,0,sy2+shifty,NULL);
	LineTo(hdc,sizex-1+shiftx,sy2+shifty);
	MoveToEx(hdc,shiftx,shifty,NULL);
	LineTo(hdc,shiftx,sizey-1+shifty);

	SelectObject(hdc,pen2);
		y=sy2-wavbuf[chan]*sy2/32768+shifty;
		x=shiftx;
		MoveToEx(hdc,x,y,NULL);
		xp=x;
		yp1=yp2=yp=y;
	for (i=1;i<num_sample;i++) {
		y=sy2-wavbuf[i*wav_channel+chan]*sy2/32768+shifty;
		x=(int)((double)i*(double)sizex/(double)num_sample)+shiftx;
			if (x>xp) {
				LineTo(hdc,xp,yp1);
				LineTo(hdc,xp,yp2);
				LineTo(hdc,xp,yp);
				LineTo(hdc,x,y);
				xp=x; yp1=yp2=yp=y;
			}
			else {
				if (y<yp1) yp1=y;
				if (y>yp2) yp2=y;
				yp=y;
			}
	}

	DeleteObject(pen1);
	DeleteObject(pen2);
}

/**
* @fn Redisplay_WAV
* @brief  WAVEf[^ʂɔg`ŕ\iCj
* @param (hwnd)  `ΏۃEBhẼnh
* @param (hdc)  `ΏۃReLXg̃nh
* @return Ȃ
* @sa Set_Draw_Window,Draw_Wave,Draw_MessW
* @detail
*/
void Redisplay_WAV(HWND hwnd,HDC hdc)
{
	if (num_sample<=0) return;
	total_time=(int)((double)num_sample*1000.0/(double)sample_freq);

	if (wav_channel>1) {
		Set_Draw_Window(100,50,0,0);
		Draw_Wave(hwnd,hdc,num_sample,wavbuf,0);
		TextOut( hdc, 10+shiftx,5+shifty,"L-channel",9);
		Set_Draw_Window(100,50,0,50);
		Draw_Wave(hwnd,hdc,num_sample,wavbuf,1);
		TextOut( hdc, 10+shiftx,5+shifty,"R-channel",9);
		Set_Draw_Window(100,100,0,0);
	}
	else {
		Draw_Wave(hwnd,hdc,num_sample,wavbuf,0);
	}
	Draw_MessW();
}

