/**
* @file WAVfile.cpp
* @brief WAVt@C̓͏
* @author T.Modegi
* @date  2023.12.25
*/
#include "StdAfx.h"
#include <stdio.h>
#include <commdlg.h>
#include "common.h"
#include "commparam.h"
#include "commdata.h"
#include "WAVfile.h"
#include "WAVdraw.h"
unsigned char *wavbuf_c;
WAVEFORMAT_HEAD wf;
WAVEFORMAT_HEAD1 wf1;
WAVEFORMAT_HEAD2 wf2;

extern HWND hWnd_main;

/**
* @fn conv_8_16
* @brief 8bitsl256{16bitstlɕϊ
* @param (c)  8bitsl
* @return 16bitstl
* @sa 
* @detail
*/
short conv_8_16(unsigned char c[]) 
{
	union {
		int i4;
		unsigned char c4[4];
		short i2[2];
	} cnv4;
	cnv4.i4=0;  cnv4.c4[0]=c[0];
	cnv4.i4=(cnv4.i4-128)*256;
	return(cnv4.i2[0]);
}

/**
* @fn conv_24_16
* @brief 24bitstl1/256{16bitstlɕϊ
* @param (c)  8bitslziRoCg24bitsf[^j
* @return 16bitstl
* @sa 
* @detail
*/
short conv_24_16(unsigned char c[]) 
{
	union {
		int i4;
		unsigned char c4[4];
	} cnv4;
	int i,v;
	short s;
	cnv4.i4=0;
	for (i=0;i<3;i++) cnv4.c4[i+1]=c[i];
	v=cnv4.i4/256;
	s=v/256;
	return(s);
}

/**
* @fn Conv_Sample_Freq
* @brief WAVEf[^Ԏɕϔ{
* @param (nch) `l
* @param (num1) WAVEf[^̃Tv
* @param (buf1) WAVEf[^16bitsz
* @param (num2) oWAVEf[^̃Tv
* @param (buf2) oWAVEf[^16bitsz
* @return Ȃ
* @sa 
* @detail
*/
void Conv_Sample_Freq(int nch,int num1,short buf1[],int num2,short buf2[])
{
	int i,j1,j2,ii;
	double scl,s,w;
	int c;
	scl=(double)num1/(double)num2;
	for (i=0;i<num2;i++) {
		s=(double)i*scl;
		j1=(int)s;
		w=s-(double)j1;
		j2=j1+1;
		if (j1>=num1) j1=num1-1;
		if (j2>=num1) {j2=num1-1;}
		if (j1==j2) w=0.0;
		for (c=0;c<nch;c++) {
			ii=(int)((double)buf1[j1*nch+c]*(1.0-w)+(double)buf1[j2*nch+c]*w);
			if (ii>32767) ii=32767;
			if (ii< -32768) ii= -32768;
			buf2[i*nch+c]=(short)ii;
		}
	}
}

/**
* @fn Read_WAVfile
* @brief WAVEt@CǂݍWAVEf[^zwavbuf\z
* @param (fname) WAV`t@C
* @return Tv
* @sa 
* @detail TvOg44100ɁAʎqrbg16bitsɕϊB
\[XWAVt@C̃TvOg͔CӁAʎqrbg24/16/8bitsɑΉA
`l1܂2
*/
/*
int Read_WAVfile(char fname[])
{
	int i;
	DWORD dwRead;
	HANDLE  hFile;
	int num;
	short *buff;
	unsigned char *cbuff;

	hFile=CreateFile(fname,GENERIC_READ,0,NULL,OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,NULL);
	if (hFile==INVALID_HANDLE_VALUE) return(-1);
	sprintf(fname_wav_bck,"%s",fname);

//  Read File 
	ReadFile(hFile,&wf1,20,&dwRead,NULL);
	ReadFile(hFile,&wf,wf1.nBytes2,&dwRead,NULL);
	if (wf.wFormatTag!=1) {  // Not Supported WAV-format
		CloseHandle(hFile);
		return(-1);
	}
	ReadFile(hFile,&wf2,8,&dwRead,NULL);

// Check Data Block
	while (wf2.tag[0]!='d' || wf2.tag[1]!='a' || wf2.tag[2]!='t' || wf2.tag[3]!='a') {
		cbuff=(unsigned char *)malloc(wf2.nBytes);
		ReadFile(hFile,cbuff,wf2.nBytes,&dwRead,NULL);
		free(cbuff);
		ReadFile(hFile,&wf2,8,&dwRead,NULL);
	}

	num=wf2.nBytes/(int)wf.nBlockAlign;
	wav_channel=wf.nChannels;
	sample_freq=44100;
	bit_per_sample=wf.wBitsPerSample;
	if (num_sample>0)  free(wavbuf);
	if (wf.nSamplesPerSec!=44100) num_sample=(int)((double)num*44100.0/(double)wf.nSamplesPerSec);
	else num_sample=num;

	if (wf.wBitsPerSample==16) {
		if (wf.nSamplesPerSec!=44100) {
			buff=(short *)malloc(wf2.nBytes);
			ReadFile(hFile,buff,wf2.nBytes,&dwRead,NULL);
		}
		else {
			wavbuf=(short *)malloc(wf2.nBytes);
			ReadFile(hFile,wavbuf,wf2.nBytes,&dwRead,NULL);
		}
	}
	else if (wf.wBitsPerSample==24) {
	  wavbuf_c=(unsigned char *)malloc(wf2.nBytes);
	  ReadFile(hFile,wavbuf_c,wf2.nBytes,&dwRead,NULL);
		if (wf.nSamplesPerSec!=44100) {
			buff=(short *)malloc(wf2.nBytes*2/3);
			for (i=0;i<num*wf.nChannels;i++)
			buff[i]=conv_24_16(&wavbuf_c[i*3]);
		}
		else {
			wavbuf=(short *)malloc(wf2.nBytes*2/3);
			for (i=0;i<num*wf.nChannels;i++)
			wavbuf[i]=conv_24_16(&wavbuf_c[i*3]);
		}
	  free(wavbuf_c);
	}
	else {
	  wavbuf_c=(unsigned char *)malloc(wf2.nBytes);
	  ReadFile(hFile,wavbuf_c,wf2.nBytes,&dwRead,NULL);
		if (wf.nSamplesPerSec!=44100) {
			buff=(short *)malloc(wf2.nBytes*2);
			for (i=0;i<num*wf.nChannels;i++)
			buff[i]=conv_8_16(&wavbuf_c[i]);
		}
		else {
			wavbuf=(short *)malloc(wf2.nBytes*2);
			for (i=0;i<num*wf.nChannels;i++)
			wavbuf[i]=conv_8_16(&wavbuf_c[i]);
		}
	  free(wavbuf_c);
	}
	CloseHandle(hFile);

	if (num!=num_sample) {
		wavbuf=(short *)malloc(num_sample*wf.nChannels*4);
		Conv_Sample_Freq(wav_channel,num,buff,num_sample,wavbuf);
		free(buff);
	}

	return(num_sample);
}
*/
int Read_WAVfile(char fname[])
{
	int i;
	DWORD dwRead;
	HANDLE  hFile;
	int num;
	short *buff;
	unsigned char *cbuff;

	hFile=CreateFile(fname,GENERIC_READ,0,NULL,OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,NULL);
	if (hFile==INVALID_HANDLE_VALUE) return(-1);
	sprintf(fname_wav_bck,"%s",fname);

//  Read File 
//	ReadFile(hFile,&wf1,20,&dwRead,NULL);
	ReadFile(hFile,&wf1,12,&dwRead,NULL);

// Check Fmt Block
	ReadFile(hFile,&wf2,8,&dwRead,NULL);
	while (wf2.tag[0]!='f' || wf2.tag[1]!='m' || wf2.tag[2]!='t' || wf2.tag[3]!=' ') {
		cbuff=(unsigned char *)malloc(wf2.nBytes);
		ReadFile(hFile,cbuff,wf2.nBytes,&dwRead,NULL);
		free(cbuff);
		ReadFile(hFile,&wf2,8,&dwRead,NULL);
	}

//	ReadFile(hFile,&wf,wf1.nBytes2,&dwRead,NULL);
	ReadFile(hFile,&wf,wf2.nBytes,&dwRead,NULL);
	if (wf.wFormatTag!=1) {  // Not Supported WAV-format
		CloseHandle(hFile);
		return(-1);
	}

// Rewind File
	SetFilePointer(hFile,0,NULL,FILE_BEGIN);
	ReadFile(hFile,&wf1,12,&dwRead,NULL);

// Check Data Block
	ReadFile(hFile,&wf2,8,&dwRead,NULL);
	while (wf2.tag[0]!='d' || wf2.tag[1]!='a' || wf2.tag[2]!='t' || wf2.tag[3]!='a') {
		cbuff=(unsigned char *)malloc(wf2.nBytes);
		ReadFile(hFile,cbuff,wf2.nBytes,&dwRead,NULL);
		free(cbuff);
		ReadFile(hFile,&wf2,8,&dwRead,NULL);
	}

	num=wf2.nBytes/(int)wf.nBlockAlign;
	wav_channel=wf.nChannels;
	sample_freq=44100;
	bit_per_sample=wf.wBitsPerSample;
	if (num_sample>0)  free(wavbuf);
	if (wf.nSamplesPerSec!=44100) num_sample=(int)((double)num*44100.0/(double)wf.nSamplesPerSec);
	else num_sample=num;

	if (wf.wBitsPerSample==16) {
		if (wf.nSamplesPerSec!=44100) {
			buff=(short *)malloc(wf2.nBytes);
			ReadFile(hFile,buff,wf2.nBytes,&dwRead,NULL);
		}
		else {
			wavbuf=(short *)malloc(wf2.nBytes);
			ReadFile(hFile,wavbuf,wf2.nBytes,&dwRead,NULL);
		}
	}
	else if (wf.wBitsPerSample==24) {
	  wavbuf_c=(unsigned char *)malloc(wf2.nBytes);
	  ReadFile(hFile,wavbuf_c,wf2.nBytes,&dwRead,NULL);
		if (wf.nSamplesPerSec!=44100) {
			buff=(short *)malloc(wf2.nBytes*2/3);
			for (i=0;i<num*wf.nChannels;i++)
			buff[i]=conv_24_16(&wavbuf_c[i*3]);
		}
		else {
			wavbuf=(short *)malloc(wf2.nBytes*2/3);
			for (i=0;i<num*wf.nChannels;i++)
			wavbuf[i]=conv_24_16(&wavbuf_c[i*3]);
		}
	  free(wavbuf_c);
	}
	else {
	  wavbuf_c=(unsigned char *)malloc(wf2.nBytes);
	  ReadFile(hFile,wavbuf_c,wf2.nBytes,&dwRead,NULL);
		if (wf.nSamplesPerSec!=44100) {
			buff=(short *)malloc(wf2.nBytes*2);
			for (i=0;i<num*wf.nChannels;i++)
			buff[i]=conv_8_16(&wavbuf_c[i]);
		}
		else {
			wavbuf=(short *)malloc(wf2.nBytes*2);
			for (i=0;i<num*wf.nChannels;i++)
			wavbuf[i]=conv_8_16(&wavbuf_c[i]);
		}
	  free(wavbuf_c);
	}
	CloseHandle(hFile);

	if (num!=num_sample) {
		wavbuf=(short *)malloc(num_sample*wf.nChannels*4);
		Conv_Sample_Freq(wav_channel,num,buff,num_sample,wavbuf);
		free(buff);
	}

	return(num_sample);
}


/**
* @fn DirListDlgProc
* @brief t@CI[vE_CAO{bNX̋N
* @param (mode) WAV/TXT/SMF̃t@Cw
* @return TRUE
* @sa
* @detail
*/
BOOL DirListDlgProc(int mode)
{
	OPENFILENAME ofn;
	memset(&ofn,0,sizeof(OPENFILENAME));
	ofn.lStructSize=sizeof(OPENFILENAME);
	ofn.hwndOwner=hWnd_main;
	if (mode==0) {
		ofn.lpstrFilter="WAV files {*.wav}\0*.wav\0";
		ofn.lpstrDefExt="wav";
	}
	else if (mode==1) {
		ofn.lpstrFilter="TXT files {*.txt}\0*.txt\0";
		ofn.lpstrDefExt="txt";
	}
	else if (mode==2) {
		ofn.lpstrFilter="SMF files {*.mid}\0*.mid\0";
		ofn.lpstrDefExt="mid";
	}
	ofn.lpstrFile=filename;
	ofn.nMaxFile=255;
	ofn.Flags=OFN_FILEMUSTEXIST;
	return(GetOpenFileName(&ofn));
}

/**
* @fn DirListDlgProc2
* @brief t@CZ[uE_CAO{bNX̋N
* @param (mode) WAV/TXT/SMF̃t@Cw
* @return TRUE
* @sa
* @detail
*/
BOOL DirListDlgProc2(int mode)
{
	int i,p,n;
	OPENFILENAME ofn;
	n=254;
	for (i=0;i<255;i++) {
		if (filename[i]=='\0') { n=i; break; }
	}
	p= -1;
	for (i=n;i>=0;i--) if (filename[i]=='.') {p=i; break;}

	memset(&ofn,0,sizeof(OPENFILENAME));
	ofn.lStructSize=sizeof(OPENFILENAME);
	ofn.hwndOwner=hWnd_main;
	if (mode==0) {
		ofn.lpstrFilter="WAV files {*.wav}\0*.wav\0";
		ofn.lpstrDefExt="wav";
		filename[p+1]='w';
		filename[p+2]='a';
		filename[p+3]='v';
	}
	else if (mode==1) {
		ofn.lpstrFilter="TXT files {*.txt}\0*.txt\0";
		ofn.lpstrDefExt="txt";
		filename[p+1]='t';
		filename[p+2]='x';
		filename[p+3]='t';
	}
	else if (mode==2) {
		ofn.lpstrFilter="SMF files {*.mid}\0*.mid\0";
		ofn.lpstrDefExt="mid";
		filename[p+1]='m';
		filename[p+2]='i';
		filename[p+3]='d';
	}
	ofn.lpstrFile=filename;
	ofn.nMaxFile=255;
	ofn.Flags=OFN_FILEMUSTEXIST;
	return(GetSaveFileName(&ofn));
}
